// D import file generated from 'tango/core/tools/Cpuid.d'
module tango.core.tools.Cpuid;
public 
{
	struct CacheInfo
	{
		uint size;
		ubyte associativity;
		uint lineSize;
	}
	public 
	{
		const(char)[] vendor();
		const(char)[] processor();
		CacheInfo[5] datacache;
		@property bool x87onChip();

		@property bool mmx();

		@property bool sse();

		@property bool sse2();

		@property bool sse3();

		@property bool ssse3();

		@property bool sse41();

		@property bool sse42();

		@property bool sse4a();

		@property bool amd3dnow();

		@property bool amd3dnowExt();

		@property bool amdMmx();

		@property bool hasFxsr();

		@property bool hasCmov();

		@property bool hasRdtsc();

		@property bool hasCmpxchg8b();

		@property bool hasCmpxchg16b();

		@property bool hasSysEnterSysExit();

		@property bool has3dnowPrefetch();

		@property bool hasLahfSahf();

		@property bool hasPopcnt();

		@property bool hasLzcnt();

		@property bool isX86_64();

		@property bool isItanium();

		@property bool hyperThreading();

		@property uint threadsPerCPU();

		@property uint coresPerCPU();

		@property bool preferAthlon();

		@property bool preferPentium4();

		@property bool preferPentium1();

		public 
		{
			uint stepping;
			uint model;
			uint family;
			uint numCacheLevels = 1;
			private 
			{
				bool probablyIntel;
				bool probablyAMD;
				char[12] vendorID;
				string processorName;
				char[48] processorNameBuffer;
				uint features = 0;
				uint miscfeatures = 0;
				uint amdfeatures = 0;
				uint amdmiscfeatures = 0;
				uint maxCores = 1;
				uint maxThreads = 1;
				bool hyperThreadingBit();
				enum : uint
				{
					FPU_BIT = 1,
					TIMESTAMP_BIT = 1 << 4,
					MDSR_BIT = 1 << 5,
					CMPXCHG8B_BIT = 1 << 8,
					SYSENTERSYSEXIT_BIT = 1 << 11,
					CMOV_BIT = 1 << 15,
					MMX_BIT = 1 << 23,
					FXSR_BIT = 1 << 24,
					SSE_BIT = 1 << 25,
					SSE2_BIT = 1 << 26,
					HTT_BIT = 1 << 28,
					IA64_BIT = 1 << 30,
				}
				enum : uint
				{
					SSE3_BIT = 1,
					PCLMULQDQ_BIT = 1 << 1,
					MWAIT_BIT = 1 << 3,
					SSSE3_BIT = 1 << 9,
					FMA_BIT = 1 << 12,
					CMPXCHG16B_BIT = 1 << 13,
					SSE41_BIT = 1 << 19,
					SSE42_BIT = 1 << 20,
					POPCNT_BIT = 1 << 23,
					AES_BIT = 1 << 25,
					OSXSAVE_BIT = 1 << 27,
					AVX_BIT = 1 << 28,
				}
				enum : uint
				{
					AMD_MMX_BIT = 1 << 22,
					FFXSR_BIT = 1 << 25,
					PAGE1GB_BIT = 1 << 26,
					RDTSCP_BIT = 1 << 27,
					AMD64_BIT = 1 << 29,
					AMD_3DNOW_EXT_BIT = 1 << 30,
					AMD_3DNOW_BIT = 1 << 31,
				}
				enum : uint
				{
					LAHFSAHF_BIT = 1,
					LZCNT_BIT = 1 << 5,
					SSE4A_BIT = 1 << 6,
					AMD_3DNOW_PREFETCH_BIT = 1 << 8,
				}
				version (GNU)
				{
				}
				else
				{
					version (D_InlineAsm_X86)
					{
						version = Really_D_InlineAsm_X86;
					}
				}
				version (Really_D_InlineAsm_X86)
				{
					uint max_cpuid;
					uint max_extended_cpuid;
					void getcacheinfoCPUID2();
					void getcacheinfoCPUID4();
					void getAMDcacheinfo();
					void getCpuInfo0B();
					void cpuidX86();
					bool hasCPUID();
				}
				else
				{
					bool hasCPUID();
					void cpuidX86();
				}
				void cpuidPPC();
				void cpuidSparc();
				shared static this();
				debug (Cpuid)
				{
					private import tango.io.Stdout;

					void main();
				}
			}
		}
	}
}
