// D import file generated from 'tango/core/tools/Demangler.d'
module tango.core.tools.Demangler;
version (TangoDemangler)
{
	import tango.core.Traits : ctfe_i2a;
	import tango.stdc.string : memmove, memcpy;
	debug (traceDemangler)
	{
		import tango.io.Stdout;
	}
	version (DigitalMars)
	{
		version (Windows)
		{
			bool isMD5Hashed(const(char)[] name);
			const(char)[] decompressOMFSymbol(const(char)[] garbled, char[]* buf);
		}
	}
	const(char)[] decompressSymbol(const(char)[] func, char[]* buf);
	uint toUint(const(char)[] s);
	public class Demangler
	{
		uint templateExpansionDepth = 1;
		bool foldDefaults = false;
		bool expandFunctionTypes = false;
		bool printTypeKind = false;
		public void verbosity(uint level);

		this();
		this(uint verbosityLevel);
		public inout(char)[] demangle(inout(char)[] input);

		public inout(char)[] demangle(inout(char)[] input, char[] output);

		struct DemangleInstance
		{
			debug (traceDemangler)
			{
				private const(char)[][] _trace;

			}
			private const(char)[] input;

			private uint _templateDepth;

			Buffer output;
			Demangler prefs;
			struct BufState
			{
				DemangleInstance* dem;
				const(char)[] input;
				size_t len;
				static BufState opCall(ref DemangleInstance dem);

				bool reset();
				bool resetOutput();
				const(char)[] sliceFrom();
			}
			BufState checkpoint();
			static DemangleInstance opCall(Demangler prefs, const(char)[] input, const(char)[] output);

			debug (traceDemangler)
			{
				private void trace(const(char)[] where);

				private template report(T...)
				{
					void report(const(char)[] fmt, T args)
					{
						int len = _trace.length;
						const(char)[] spaces = "            ";
						spaces = spaces[0..len < spaces.length ? len : spaces.length];
						Stdout(spaces);
						Stdout.formatln(fmt, args);
					}

				}

				private void trace(bool result);

			}
			const(char)[] slice();
			private const(char)[] consume(uint amt);

			bool mangledName();
			bool typedqualifiedName();
			bool qualifiedName(bool aliasHack = false);
			bool symbolName(bool aliasHack = false);
			bool lName();
			bool lNameAliasHack();
			bool number(ref uint value);
			bool numberNoParse();
			bool name(uint count);
			bool type();
			bool typeFunction();
			bool arguments();
			bool argument();
			bool typeNamed();
			bool templateInstanceName();
			bool templateArgs();
			bool templateArg();
			bool value();
			bool hexFloat();
			static bool isHexDigit(char c);

			bool hexNumber(ref ulong value);
		}
	}

	private struct Buffer
	{
		char[] data;
		size_t length;
		void append(const(char)[] s);
		void append(char c);
		void append(Buffer b);
		template slice()
		{
			const(char)[] slice()
			{
				return data[0..this.length];
			}

		}
	}

	static Demangler demangler;

	static this();
}
else
{
	import core = core.demangle;
	public class Demangler
	{
		public inout(char)[] demangle(inout(char)[] input);

		public inout(char)[] demangle(inout(char)[] input, char[] output);

	}

	static Demangler demangler;

	static this();
}
