// D import file generated from 'tango/core/tools/StackTrace.d'
module tango.core.tools.StackTrace;
import tango.core.tools.Demangler;
import tango.core.Runtime;
import tango.core.Thread;
import tango.core.Traits : ctfe_i2a;
import tango.stdc.string;
import tango.stdc.stringz : fromStringz;
import tango.stdc.stdlib : abort;
import tango.core.tools.FrameInfo;
version (Windows)
{
	import tango.core.tools.WinStackTrace;
}
else
{
	import tango.stdc.posix.ucontext;
	import tango.stdc.posix.sys.types : pid_t, pthread_t;
	import tango.stdc.signal;
	import tango.stdc.stdlib;
}
version (linux)
{
	import tango.core.tools.LinuxStackTrace;
}
version (CatchRecursiveTracing)
{
	__gshared ThreadLocal!(int) recursiveStackTraces;

	shared static this();
}
version (Windows)
{
}
else
{
	struct TraceContext
	{
		bool hasContext;
		ucontext_t context;
		pid_t hProcess;
		pthread_t hThread;
	}
}
alias size_t function(TraceContext* context, TraceContext* contextOut, size_t* traceBuf, size_t bufLength, int* flags) AddrBacktraceFunc;
__gshared AddrBacktraceFunc addrBacktraceFnc;

alias bool function(ref FrameInfo fInfo, const(TraceContext)* context, char[] buf) SymbolizeFrameInfoFnc;
__gshared SymbolizeFrameInfoFnc symbolizeFrameInfoFnc;

shared static this();
extern (C) void rt_setAddrBacktraceFnc(AddrBacktraceFunc f);

extern (C) void rt_setSymbolizeFrameInfoFnc(SymbolizeFrameInfoFnc f);

extern (C) Exception.TraceInfo rt_createTraceContext(void* ptr);

alias Exception.TraceInfo function(void* ptr = null) TraceHandler;
extern (C) size_t rt_addrBacktrace(TraceContext* context, TraceContext* contextOut, size_t* traceBuf, size_t bufLength, int* flags);

extern (C) bool rt_symbolizeFrameInfo(ref FrameInfo fInfo, const(TraceContext)* context, char[] buf);

__gshared int[const(char)[]] internalFuncs;

shared static this();
const(char[])[] internalMethodEnders = ["8__assertFiZv", "9__requireMFZv"];
bool isInternalMethod(const(char)[] name);
const(char)[] nameOfFunctionAt(void* addr, char[] buf);
const(char)[] nameOfFunctionAt(void* addr);
enum AddrPrecision 
{
	AllReturn = 0,
	TopExact = 1,
	AllExact = 3,
}
class BasicTraceInfo : Throwable.TraceInfo
{
	size_t[] traceAddresses;
	size_t[128] traceBuf;
	AddrPrecision addrPrecision;
	TraceContext context;
	this();
	this(size_t[] traceAddresses, AddrPrecision addrPrecision);
	void trace(TraceContext* contextIn = null, int skipFrames = 0);
	override const int opApply(scope int delegate(ref const(char[])) dg);

	override const int opApply(scope int delegate(ref size_t line, ref const(char[]) func) loopBody);

	const int opApply(scope int delegate(ref FrameInfo fInfo) loopBody);
	const void writeOut(scope void delegate(const(char[])) sink);
	override const immutable(char)[] toString();

}
version (linux)
{
	version = LibCBacktrace;
	version = DladdrSymbolification;
	version = ElfSymbolification;
}
version (darwin)
{
	version = LibCBacktrace;
	version = DladdrSymbolification;
}
version (LibCBacktrace)
{
	extern (C) int backtrace(void**, int);

}
size_t defaultAddrBacktrace(TraceContext* context, TraceContext* contextOut, size_t* traceBuf, size_t length, int* flags);
version (DladdrSymbolification)
{
	extern (C) struct Dl_info
	{
		char* dli_fname;
		void* dli_fbase;
		char* dli_sname;
		void* dli_saddr;
	}

	extern (C) int dladdr(void* addr, Dl_info* info);

	bool dladdrSymbolizeFrameInfo(ref FrameInfo fInfo, const(TraceContext)* context, char[] buf);
}
version (ElfSymbolification)
{
	version (TangoDoc)
	{
		bool elfSymbolizeFrameInfo(ref FrameInfo fInfo, const(TraceContext)* context, char[] buf);
	}
	else
	{
		bool elfSymbolizeFrameInfo(ref FrameInfo fInfo, const(TraceContext)* context, char[] buf);
	}
}
bool defaultSymbolizeFrameInfo(ref FrameInfo fInfo, const(TraceContext)* context, char[] buf);
Exception.TraceInfo basicTracer(void* ptr = null);
version (Posix)
{
	version (linux)
	{
		version (X86)
		{
			version = haveSegfaultTrace;
		}
		else
		{
			version (X86_64)
			{
				version = haveSegfaultTrace;
			}
		}
	}
	extern (C) void tango_stacktrace_fault_handler(int sn, siginfo_t* si, void* ctx);

	__gshared sigaction_t fault_action;

	void setupSegfaultTracer();
	version (noSegfaultTrace)
	{
	}
	else
	{
		shared static this();
	}
}
else
{
	version (Windows)
	{
	}
	else
	{
		pragma (msg, "[INFO] SEGFAULT trace not yet implemented for this OS");
	}
}
