// D import file generated from 'tango/core/tools/WinStackTrace.d'
module tango.core.tools.WinStackTrace;
version (Windows)
{
	import tango.core.Thread;
	import tango.core.tools.FrameInfo;
	version (D_Version2)
	{
		private const(char)[] intToUtf8(char[] tmp, uint val);

		private int stringCompare(in char[] s1, in char[] s2);

	}
	private 
	{
		import tango.core.tools.Demangler;
		import tango.core.Runtime;
		static import tango.stdc.stdlib;
		static import tango.stdc.string;
		version (StacktraceSpam)
		{
			import tango.stdc.stdio : printf;
		}
	}
	version = StacktraceTryMatchCallAddresses;
	version = StacktraceTryToBeSmart;
	version = DemangleFunctionNames;
	struct TraceContext
	{
		LPCONTEXT context;
		HANDLE hProcess;
		HANDLE hThread;
	}
	size_t winAddrBacktrace(TraceContext* winCtx, TraceContext* contextOut, size_t* traceBuf, size_t traceBufLength, int* flags);
	bool winSymbolizeFrameInfo(ref FrameInfo fInfo, const(TraceContext)* context, char[] buf);
	private extern (C) 
	{
		void _Dmain();
		void D4core6thread5Fiber3runMFZv();
	}

	private size_t fiberRunFuncLength = 0;

	struct Context
	{
		void* bstack;
		void* tstack;
		Context* within;
		Context* next;
		Context* prev;
	}
	extern (C) Context* D4core6thread6Thread10topContextMFZPS4core6thread6Thread7Context(core.thread.Thread);

	alias D4core6thread6Thread10topContextMFZPS4core6thread6Thread7Context Thread_topContext;
	void walkStack(LPCONTEXT ContextRecord, HANDLE hProcess, HANDLE hThread, void delegate(size_t[]) traceReceiver);
	bool addrToSymbolDetails(size_t addr, HANDLE hProcess, void delegate(const(char)[] func, const(char)[] file, int line, ptrdiff_t addrOffset) dg);
	private import tango.stdc.stdlib : cMalloc = malloc, cRealloc = realloc, cFree = free;

	public import tango.stdc.string : memset;

	template alloc(T, intT)
	{
		void alloc(ref T array, intT numItems, bool init = true)
		in
		{
			assert(array is null);
			assert(numItems >= 0);
		}
		out
		{
			assert(numItems == array.length);
		}
		body
		{
			alias typeof(T.init[0]) ItemT;
			array = (cast(ItemT*)cMalloc(ItemT.sizeof * numItems))[0..numItems];
			static if (is(typeof(ItemT.init)))
			{
				if (init)
				{
					array[] = ItemT.init;
				}
			}

		}

	}
	template clone(T)
	{
		T clone(T array)
		{
			T res;
			res.alloc(array.length, false);
			res[] = array[];
			return res;
		}

	}
	template realloc(T, intT)
	{
		void realloc(ref T array, intT numItems, bool init = true)
		in
		{
			assert(numItems >= 0);
		}
		out
		{
			assert(numItems == array.length);
		}
		body
		{
			alias typeof(T.init[0]) ItemT;
			intT oldLen = array.length;
			array = (cast(ItemT*)cRealloc(array.ptr, ItemT.sizeof * numItems))[0..numItems];
			static if (is(typeof(ItemT.init)))
			{
				if (init && numItems > oldLen)
				{
					array[oldLen..numItems] = ItemT.init;
				}
			}

		}

	}
	template free(T)
	{
		void free(ref T array)
		out
		{
			assert(0 == array.length);
		}
		body
		{
			cFree(array.ptr);
			array = null;
		}

	}
	template append(T, I)
	{
		void append(ref T array, I elem, uint* realLength = null)
		{
			uint len = realLength is null ? array.length : *realLength;
			uint capacity = array.length;
			alias typeof(T.init[0]) ItemT;
			if (len >= capacity)
			{
				if (realLength is null)
				{
					int numItems = len + 1;
					array = (cast(ItemT*)cRealloc(array.ptr, ItemT.sizeof * numItems))[0..numItems];
				}
				else
				{
					const uint initialCapacity = 4;
					int numItems = capacity == 0 ? initialCapacity : capacity * 2;
					array = (cast(ItemT*)cRealloc(array.ptr, ItemT.sizeof * numItems))[0..numItems];
					++(*realLength);
				}
			}
			else
				if (realLength !is null)
					++(*realLength);
			array[len] = elem;
		}

	}
	import tango.text.Util;
	import tango.core.Thread;
	import tango.core.Array;
	import tango.sys.Common : SysError;
	import tango.sys.SharedLib : SharedLib;
	import tango.stdc.stdio;
	import tango.stdc.string;
	import tango.stdc.stringz;
	enum 
	{
		MAX_PATH = 260,
	}
	enum : WORD
	{
		IMAGE_FILE_MACHINE_UNKNOWN = 0,
		IMAGE_FILE_MACHINE_I386 = 332,
		IMAGE_FILE_MACHINE_R3000 = 354,
		IMAGE_FILE_MACHINE_R4000 = 358,
		IMAGE_FILE_MACHINE_R10000 = 360,
		IMAGE_FILE_MACHINE_ALPHA = 388,
		IMAGE_FILE_MACHINE_POWERPC = 496,
	}
	version (X86)
	{
		const SIZE_OF_80387_REGISTERS = 80;
		const CONTEXT_i386 = 65536;
		const CONTEXT_i486 = 65536;
		const CONTEXT_CONTROL = CONTEXT_i386 | 1L;
		const CONTEXT_INTEGER = CONTEXT_i386 | 2L;
		const CONTEXT_SEGMENTS = CONTEXT_i386 | 4L;
		const CONTEXT_FLOATING_POINT = CONTEXT_i386 | 8L;
		const CONTEXT_DEBUG_REGISTERS = CONTEXT_i386 | 16L;
		const CONTEXT_EXTENDED_REGISTERS = CONTEXT_i386 | 32L;
		const CONTEXT_FULL = CONTEXT_CONTROL | CONTEXT_INTEGER | CONTEXT_SEGMENTS;
		const MAXIMUM_SUPPORTED_EXTENSION = 512;
		struct FLOATING_SAVE_AREA
		{
			DWORD ControlWord;
			DWORD StatusWord;
			DWORD TagWord;
			DWORD ErrorOffset;
			DWORD ErrorSelector;
			DWORD DataOffset;
			DWORD DataSelector;
			BYTE[80] RegisterArea;
			DWORD Cr0NpxState;
		}
		struct CONTEXT
		{
			DWORD ContextFlags;
			DWORD Dr0;
			DWORD Dr1;
			DWORD Dr2;
			DWORD Dr3;
			DWORD Dr6;
			DWORD Dr7;
			FLOATING_SAVE_AREA FloatSave;
			DWORD SegGs;
			DWORD SegFs;
			DWORD SegEs;
			DWORD SegDs;
			DWORD Edi;
			DWORD Esi;
			DWORD Ebx;
			DWORD Edx;
			DWORD Ecx;
			DWORD Eax;
			DWORD Ebp;
			DWORD Eip;
			DWORD SegCs;
			DWORD EFlags;
			DWORD Esp;
			DWORD SegSs;
			BYTE[MAXIMUM_SUPPORTED_EXTENSION] ExtendedRegisters;
		}
	}
	else
	{
		pragma (msg, "Unsupported CPU");
		static assert(0);
	}
	alias CONTEXT* PCONTEXT;
	alias CONTEXT* LPCONTEXT;
	alias void* HANDLE;
	alias char CHAR;
	alias void* PVOID;
	alias void* LPVOID;
	alias wchar WCHAR;
	alias WCHAR* PWCHAR;
	alias WCHAR* LPWCH;
	alias WCHAR* PWCH;
	alias WCHAR* LPWSTR;
	alias WCHAR* PWSTR;
	alias CHAR* PCHAR;
	alias CHAR* LPCH;
	alias CHAR* PCH;
	alias CHAR* LPSTR;
	alias CHAR* PSTR;
	alias const(WCHAR)* LPCWCH;
	alias const(WCHAR)* PCWCH;
	alias const(WCHAR)* LPCWSTR;
	alias const(WCHAR)* PCWSTR;
	alias const(CHAR)* LPCCH;
	alias const(CHAR)* PCSTR;
	alias const(CHAR)* LPCSTR;
	version (Unicode)
	{
		alias WCHAR TCHAR;
		alias WCHAR _TCHAR;
	}
	else
	{
		alias CHAR TCHAR;
		alias CHAR _TCHAR;
	}
	alias TCHAR* PTCH;
	alias TCHAR* PTBYTE;
	alias TCHAR* LPTCH;
	alias TCHAR* PTSTR;
	alias TCHAR* LPTSTR;
	alias TCHAR* LP;
	alias TCHAR* PTCHAR;
	alias TCHAR* LPCTSTR;
	alias ubyte BYTE;
	alias ubyte* PBYTE;
	alias ubyte* LPBYTE;
	alias ushort USHORT;
	alias ushort WORD;
	alias ushort ATOM;
	alias ushort* PUSHORT;
	alias ushort* PWORD;
	alias ushort* LPWORD;
	alias uint ULONG;
	alias uint DWORD;
	alias uint UINT;
	alias uint COLORREF;
	alias uint* PULONG;
	alias uint* PDWORD;
	alias uint* LPDWORD;
	alias uint* PUINT;
	alias uint* LPUINT;
	alias int BOOL;
	alias int INT;
	alias int LONG;
	alias HANDLE HMODULE;
	enum : BOOL
	{
		FALSE = 0,
		TRUE = 1,
	}
	struct EXCEPTION_POINTERS
	{
		void* ExceptionRecord;
		CONTEXT* ContextRecord;
	}
	version (Win64)
	{
		alias long INT_PTR;
		alias long LONG_PTR;
		alias ulong UINT_PTR;
		alias ulong ULONG_PTR;
		alias ulong HANDLE_PTR;
	}
	else
	{
		alias int INT_PTR;
		alias int LONG_PTR;
		alias uint UINT_PTR;
		alias uint ULONG_PTR;
		alias uint HANDLE_PTR;
	}
	alias ulong ULONG64;
	alias ulong DWORD64;
	alias ulong UINT64;
	alias ulong* PULONG64;
	alias ulong* PDWORD64;
	alias ulong* PUINT64;
	extern (Windows) 
	{
		HANDLE GetCurrentProcess();
		HANDLE GetCurrentThread();
		BOOL GetThreadContext(HANDLE, LPCONTEXT);
	}
	void loadWinAPIFunctions();
	extern (Windows) 
	{
		__gshared fp_SymFromAddr SymFromAddr;

		__gshared fp_SymFromName SymFromName;

		__gshared fp_SymLoadModule64 SymLoadModule64;

		__gshared fp_SymInitialize SymInitialize;

		__gshared fp_SymCleanup SymCleanup;

		__gshared fp_SymSetOptions SymSetOptions;

		__gshared fp_SymGetLineFromAddr64 SymGetLineFromAddr64;

		__gshared fp_SymEnumSymbols SymEnumSymbols;

		__gshared fp_SymGetModuleBase64 SymGetModuleBase64;

		__gshared fp_GetModuleFileNameExA GetModuleFileNameExA;

		__gshared fp_StackWalk64 StackWalk64;

		__gshared fp_SymFunctionTableAccess64 SymFunctionTableAccess64;

		alias DWORD function(DWORD SymOptions) fp_SymSetOptions;
		enum 
		{
			SYMOPT_ALLOW_ABSOLUTE_SYMBOLS = 2048,
			SYMOPT_DEFERRED_LOADS = 4,
			SYMOPT_UNDNAME = 2,
		}
		alias BOOL function(HANDLE hProcess, LPCTSTR UserSearchPath, BOOL fInvadeProcess) fp_SymInitialize;
		alias BOOL function(HANDLE hProcess) fp_SymCleanup;
		alias DWORD64 function(HANDLE hProcess, HANDLE hFile, LPCSTR ImageName, LPCSTR ModuleName, DWORD64 BaseOfDll, DWORD SizeOfDll) fp_SymLoadModule64;
		struct SYMBOL_INFO
		{
			ULONG SizeOfStruct;
			ULONG TypeIndex;
			ULONG64[2] Reserved;
			ULONG Index;
			ULONG Size;
			ULONG64 ModBase;
			ULONG Flags;
			ULONG64 Value;
			ULONG64 Address;
			ULONG Register;
			ULONG Scope;
			ULONG Tag;
			ULONG NameLen;
			ULONG MaxNameLen;
			TCHAR[1] Name;
		}
		alias SYMBOL_INFO* PSYMBOL_INFO;
		alias BOOL function(HANDLE hProcess, DWORD64 Address, PDWORD64 Displacement, PSYMBOL_INFO Symbol) fp_SymFromAddr;
		alias BOOL function(HANDLE hProcess, PCSTR Name, PSYMBOL_INFO Symbol) fp_SymFromName;
		alias BOOL function(HANDLE hProcess, PSYM_ENUMMODULES_CALLBACK64 EnumModulesCallback, PVOID UserContext) fp_SymEnumerateModules64;
		alias BOOL function(LPTSTR ModuleName, DWORD64 BaseOfDll, PVOID UserContext) PSYM_ENUMMODULES_CALLBACK64;
		const DWORD TH32CS_SNAPPROCESS = 2;

		const DWORD TH32CS_SNAPTHREAD = 4;

		enum 
		{
			MAX_MODULE_NAME32 = 255,
			TH32CS_SNAPMODULE = 8,
			SYMOPT_LOAD_LINES = 16,
		}
		struct IMAGEHLP_LINE64
		{
			DWORD SizeOfStruct;
			PVOID Key;
			DWORD LineNumber;
			PTSTR FileName;
			DWORD64 Address;
		}
		alias IMAGEHLP_LINE64* PIMAGEHLP_LINE64;
		alias BOOL function(HANDLE hProcess, DWORD64 dwAddr, PDWORD pdwDisplacement, PIMAGEHLP_LINE64 Line) fp_SymGetLineFromAddr64;
		alias BOOL function(PSYMBOL_INFO pSymInfo, ULONG SymbolSize, PVOID UserContext) PSYM_ENUMERATESYMBOLS_CALLBACK;
		alias BOOL function(HANDLE hProcess, ULONG64 BaseOfDll, LPCTSTR Mask, PSYM_ENUMERATESYMBOLS_CALLBACK EnumSymbolsCallback, PVOID UserContext) fp_SymEnumSymbols;
		alias DWORD64 function(HANDLE hProcess, DWORD64 dwAddr) fp_SymGetModuleBase64;
		alias fp_SymGetModuleBase64 PGET_MODULE_BASE_ROUTINE64;
		alias DWORD function(HANDLE hProcess, HMODULE hModule, LPSTR lpFilename, DWORD nSize) fp_GetModuleFileNameExA;
		enum ADDRESS_MODE 
		{
			AddrMode1616,
			AddrMode1632,
			AddrModeReal,
			AddrModeFlat,
		}
		struct KDHELP64
		{
			DWORD64 Thread;
			DWORD ThCallbackStack;
			DWORD ThCallbackBStore;
			DWORD NextCallback;
			DWORD FramePointer;
			DWORD64 KiCallUserMode;
			DWORD64 KeUserCallbackDispatcher;
			DWORD64 SystemRangeStart;
			DWORD64 KiUserExceptionDispatcher;
			DWORD64 StackBase;
			DWORD64 StackLimit;
			DWORD64[5] Reserved;
		}
		alias KDHELP64* PKDHELP64;
		struct ADDRESS64
		{
			DWORD64 Offset;
			WORD Segment;
			ADDRESS_MODE Mode;
		}
		alias ADDRESS64* LPADDRESS64;
		struct STACKFRAME64
		{
			ADDRESS64 AddrPC;
			ADDRESS64 AddrReturn;
			ADDRESS64 AddrFrame;
			ADDRESS64 AddrStack;
			ADDRESS64 AddrBStore;
			PVOID FuncTableEntry;
			DWORD64[4] Params;
			BOOL Far;
			BOOL Virtual;
			DWORD64[3] Reserved;
			KDHELP64 KdHelp;
		}
		alias STACKFRAME64* LPSTACKFRAME64;
		alias BOOL function(HANDLE hProcess, DWORD64 lpBaseAddress, PVOID lpBuffer, DWORD nSize, LPDWORD lpNumberOfBytesRead) PREAD_PROCESS_MEMORY_ROUTINE64;
		alias PVOID function(HANDLE hProcess, DWORD64 AddrBase) PFUNCTION_TABLE_ACCESS_ROUTINE64;
		alias PFUNCTION_TABLE_ACCESS_ROUTINE64 fp_SymFunctionTableAccess64;
		alias DWORD64 function(HANDLE hProcess, HANDLE hThread, LPADDRESS64 lpaddr) PTRANSLATE_ADDRESS_ROUTINE64;
		alias BOOL function(DWORD MachineType, HANDLE hProcess, HANDLE hThread, LPSTACKFRAME64 StackFrame, PVOID ContextRecord, PREAD_PROCESS_MEMORY_ROUTINE64 ReadMemoryRoutine, PFUNCTION_TABLE_ACCESS_ROUTINE64 FunctionTableAccessRoutine, PGET_MODULE_BASE_ROUTINE64 GetModuleBaseRoutine, PTRANSLATE_ADDRESS_ROUTINE64 TranslateAddress) fp_StackWalk64;
		BOOL IsBadReadPtr(void*, uint);
	}
	import tango.text.Util;
	import tango.stdc.stdio;
	import tango.stdc.stringz;
	import tango.stdc.string : strcpy;
	import tango.sys.win32.CodePage;
	import tango.core.Exception;
	struct AddrDebugInfo
	{
		align (1)
		{
			size_t addr;
			char* file;
			char* func;
			ushort line;
		}
	}
	class ModuleDebugInfo
	{
		AddrDebugInfo[] debugInfo;
		uint debugInfoLen;
		size_t[char*] fileMaxAddr;
		char*[] strBuffer;
		uint strBufferLen;
		void addDebugInfo(size_t addr, char* file, char* func, ushort line);
		char* bufferString(const(char)[] str);
		void freeArrays();
		ModuleDebugInfo prev;
		ModuleDebugInfo next;
	}
	class GlobalDebugInfo
	{
		ModuleDebugInfo head;
		ModuleDebugInfo tail;
		int opApply(scope int delegate(ref ModuleDebugInfo) dg);
		void addDebugInfo(ModuleDebugInfo info);
		void removeDebugInfo(ModuleDebugInfo info);
	}
	private __gshared GlobalDebugInfo globalDebugInfo;


	shared static this();
	extern (C) void _initLGPLHostExecutableDebugInfo(const(char)[] progName);

	AddrDebugInfo getAddrDbgInfo(size_t a, ptrdiff_t* diff = null);
	class DebugInfo
	{
		ModuleDebugInfo info;
		this(const(char)[] filename);
		private 
		{
			int ParseCVFile(const(char)[] filename);
			bool ParseFileHeaders(FILE* debugfile);
			CVHeaderType GetHeaderType(FILE* debugfile);
			bool ReadDOSFileHeader(FILE* debugfile, IMAGE_DOS_HEADER* doshdr);
			bool ReadPEFileHeader(FILE* debugfile, IMAGE_NT_HEADERS* nthdr);
			bool ParseSectionHeaders(FILE* debugfile);
			bool ReadSectionHeaders(FILE* debugfile, ref IMAGE_SECTION_HEADER[] secthdrs);
			bool ParseDebugDir(FILE* debugfile);
			uint GetOffsetFromRVA(uint rva);
			bool ReadDebugDir(FILE* debugfile, ref IMAGE_DEBUG_DIRECTORY[] debugdirs);
			bool ParseCodeViewHeaders(FILE* debugfile);
			bool ReadCodeViewHeader(FILE* debugfile, out OMFSignature sig, out OMFDirHeader dirhdr);
			bool ReadCodeViewDirectory(FILE* debugfile, ref OMFDirEntry[] entries);
			bool ParseAllModules(FILE* debugfile);
			bool ReadModuleData(FILE* debugfile, OMFDirEntry[] entries, out OMFModuleFull[] modules);
			bool ParseRelatedSections(int index, FILE* debugfile);
			bool ParseSrcModuleInfo(int index, FILE* debugfile);
			void ExtractSrcModuleInfo(byte* rawdata, short* filecount, short* segcount, out uint[] fileinfopos);
			void ExtractSrcModuleFileInfo(byte* rawdata, out uint[] offset);
			void ExtractSrcModuleLineInfo(byte* rawdata, int tablecount);
			bool ReadChunk(FILE* debugfile, void* dest, int length, int fileoffset);
			enum CVHeaderType : int
			{
				NONE,
				DOS,
				NT,
				DBG,
			}
			int g_dwStartOfCodeView = 0;
			bool g_exe_mode = true;
			IMAGE_DOS_HEADER g_doshdr;
			IMAGE_SEPARATE_DEBUG_HEADER g_dbghdr;
			IMAGE_NT_HEADERS g_nthdr;
			IMAGE_SECTION_HEADER[] g_secthdrs;
			IMAGE_DEBUG_DIRECTORY[] g_debugdirs;
			OMFSignature g_cvSig;
			OMFDirHeader g_cvHeader;
			OMFDirEntry[] g_cvEntries;
			OMFModuleFull[] g_cvModules;
			const(char)[] g_filename;
			char* g_filenameStringz;
		}
	}
	enum 
	{
		IMAGE_FILE_DEBUG_DIRECTORY = 6,
	}
	enum 
	{
		sstModule = 288,
		sstSrcModule = 295,
		sstGlobalPub = 298,
	}
	struct OMFSignature
	{
		char[4] Signature;
		int filepos;
	}
	struct OMFDirHeader
	{
		ushort cbDirHeader;
		ushort cbDirEntry;
		uint cDir;
		int lfoNextDir;
		uint flags;
	}
	struct OMFDirEntry
	{
		ushort SubSection;
		ushort iMod;
		int lfo;
		uint cb;
	}
	struct OMFSegDesc
	{
		ushort Seg;
		ushort pad;
		uint Off;
		uint cbSeg;
	}
	struct OMFModule
	{
		ushort ovlNumber;
		ushort iLib;
		ushort cSeg;
		char[2] Style;
	}
	struct OMFModuleFull
	{
		ushort ovlNumber;
		ushort iLib;
		ushort cSeg;
		char[2] Style;
		OMFSegDesc* SegInfo;
		char* Name;
	}
	struct OMFSymHash
	{
		ushort symhash;
		ushort addrhash;
		uint cbSymbol;
		uint cbHSym;
		uint cbHAddr;
	}
	struct DATASYM16
	{
		ushort reclen;
		ushort rectyp;
		int off;
		ushort seg;
		ushort typind;
		byte[1] name;
	}
	alias DATASYM16 PUBSYM16;
	struct IMAGE_DOS_HEADER
	{
		ushort e_magic;
		ushort e_cblp;
		ushort e_cp;
		ushort e_crlc;
		ushort e_cparhdr;
		ushort e_minalloc;
		ushort e_maxalloc;
		ushort e_ss;
		ushort e_sp;
		ushort e_csum;
		ushort e_ip;
		ushort e_cs;
		ushort e_lfarlc;
		ushort e_ovno;
		ushort[4] e_res;
		ushort e_oemid;
		ushort e_oeminfo;
		ushort[10] e_res2;
		int e_lfanew;
	}
	struct IMAGE_FILE_HEADER
	{
		ushort Machine;
		ushort NumberOfSections;
		uint TimeDateStamp;
		uint PointerToSymbolTable;
		uint NumberOfSymbols;
		ushort SizeOfOptionalHeader;
		ushort Characteristics;
	}
	struct IMAGE_SEPARATE_DEBUG_HEADER
	{
		ushort Signature;
		ushort Flags;
		ushort Machine;
		ushort Characteristics;
		uint TimeDateStamp;
		uint CheckSum;
		uint ImageBase;
		uint SizeOfImage;
		uint NumberOfSections;
		uint ExportedNamesSize;
		uint DebugDirectorySize;
		uint SectionAlignment;
		uint[2] Reserved;
	}
	struct IMAGE_DATA_DIRECTORY
	{
		uint VirtualAddress;
		uint Size;
	}
	struct IMAGE_OPTIONAL_HEADER
	{
		ushort Magic;
		byte MajorLinkerVersion;
		byte MinorLinkerVersion;
		uint SizeOfCode;
		uint SizeOfInitializedData;
		uint SizeOfUninitializedData;
		uint AddressOfEntryPoint;
		uint BaseOfCode;
		uint BaseOfData;
		uint ImageBase;
		uint SectionAlignment;
		uint FileAlignment;
		ushort MajorOperatingSystemVersion;
		ushort MinorOperatingSystemVersion;
		ushort MajorImageVersion;
		ushort MinorImageVersion;
		ushort MajorSubsystemVersion;
		ushort MinorSubsystemVersion;
		uint Win32VersionValue;
		uint SizeOfImage;
		uint SizeOfHeaders;
		uint CheckSum;
		ushort Subsystem;
		ushort DllCharacteristics;
		uint SizeOfStackReserve;
		uint SizeOfStackCommit;
		uint SizeOfHeapReserve;
		uint SizeOfHeapCommit;
		uint LoaderFlags;
		uint NumberOfRvaAndSizes;
		enum 
		{
			IMAGE_NUMBEROF_DIRECTORY_ENTRIES = 16,
		}
		IMAGE_DATA_DIRECTORY[IMAGE_NUMBEROF_DIRECTORY_ENTRIES] DataDirectory;
	}
	struct IMAGE_NT_HEADERS
	{
		uint Signature;
		IMAGE_FILE_HEADER FileHeader;
		IMAGE_OPTIONAL_HEADER OptionalHeader;
	}
	enum 
	{
		IMAGE_SIZEOF_SHORT_NAME = 8,
	}
	struct IMAGE_SECTION_HEADER
	{
		byte[IMAGE_SIZEOF_SHORT_NAME] Name;
		union misc
		{
			uint PhysicalAddress;
			uint VirtualSize;
		}
		misc Misc;
		uint VirtualAddress;
		uint SizeOfRawData;
		uint PointerToRawData;
		uint PointerToRelocations;
		uint PointerToLinenumbers;
		ushort NumberOfRelocations;
		ushort NumberOfLinenumbers;
		uint Characteristics;
	}
	struct IMAGE_DEBUG_DIRECTORY
	{
		uint Characteristics;
		uint TimeDateStamp;
		ushort MajorVersion;
		ushort MinorVersion;
		uint Type;
		uint SizeOfData;
		uint AddressOfRawData;
		uint PointerToRawData;
	}
	struct OMFSourceLine
	{
		ushort Seg;
		ushort cLnOff;
		uint[1] offset;
		ushort[1] lineNbr;
	}
	struct OMFSourceFile
	{
		ushort cSeg;
		ushort reserved;
		uint[1] baseSrcLn;
		ushort cFName;
		char Name;
	}
	struct OMFSourceModule
	{
		ushort cFile;
		ushort cSeg;
		uint[1] baseSrcFile;
	}
	extern (C) 
	{
		ModuleDebugInfo ModuleDebugInfo_new();
		void ModuleDebugInfo_addDebugInfo(ModuleDebugInfo minfo, size_t addr, char* file, char* func, ushort line);
		char* ModuleDebugInfo_bufferString(ModuleDebugInfo minfo, char[] str);
		void GlobalDebugInfo_addDebugInfo(ModuleDebugInfo minfo);
		void GlobalDebugInfo_removeDebugInfo(ModuleDebugInfo minfo);
	}
	shared static this();
}
