// D import file generated from 'tango/io/Console.d'
module tango.io.Console;
private import tango.sys.Common;

private 
{
	import tango.io.device.Device;
	import tango.io.stream.Buffered;
}
version (Posix)
{
	private import tango.stdc.posix.unistd;

}
struct Console
{
	version (Win32)
	{
		immutable __gshared immutable(char)[] Eol = "\x0d\x0a";

	}
	else
	{
		immutable __gshared immutable(char)[] Eol = "\x0a";

	}
	class Input
	{
		private Bin buffer;

		private bool redirect;

		public alias copyln get;

		private this(Conduit conduit, bool redirected);

		final char[] copyln(bool raw = false);

		final bool readln(ref char[] content, bool raw = false);

		final @property InputStream stream();

		final @property bool redirected();

		final @property Input redirected(bool yes);

		final @property InputStream input();

		final @property Input input(InputStream source);

	}
	class Output
	{
		private Bout buffer;

		private bool redirect;

		public alias append opCall;

		public alias flush opCall;

		private this(Conduit conduit, bool redirected);

		final Output append(const(char[]) x);

		final Output append(Object other);

		final @property Output newline();

		final Output flush();

		final @property OutputStream stream();

		final @property bool redirected();

		final @property Output redirected(bool yes);

		final @property OutputStream output();

		final @property Output output(OutputStream sink);

	}
	class Conduit : Device
	{
		private bool redirected = false;

		override immutable(char)[] toString();

		version (Win32)
		{
			private wchar[] input;

			private wchar[] output;

			this(size_t handle);
			private void reopen(size_t handle_);

			version (Win32SansUnicode)
			{
			}
			else
			{
				override size_t write(const(void)[] src);

			}
			version (Win32SansUnicode)
			{
			}
			else
			{
				protected override size_t read(void[] dst);


			}
		}
		else
		{
			private this(size_t handle);

		}
	}
}
static __gshared Console.Input Cin;

static __gshared Console.Output Cout;

static __gshared Console.Output Cerr;

shared static this();
debug (Console)
{
	void main();
}
