// D import file generated from 'tango/io/FilePath.d'
module tango.io.FilePath;
private import tango.io.Path;

private import tango.io.model.IFile : FileConst, FileInfo;

private import tango.stdc.string : memmove;

class FilePath : PathView
{
	private PathParser!(char) p;

	private bool dir_;

	final template opOpAssign(immutable(char)[] s : "~")
	{
		FilePath opOpAssign(const(char)[] path)
		{
			return append(path);
		}

	}

	public alias bool delegate(FilePath, bool) Filter;

	static FilePath opCall(char[] filepath = null);

	this(char[] filepath = null);
	const final override string toString();

	const final @property FilePath dup();

	final inout inout(char)[] cString();

	final @property inout inout(char)[] root();

	final @property inout inout(char)[] folder();

	final @property inout inout(char)[] parent();

	final @property inout inout(char)[] name();

	final @property char[] ext();

	final @property inout inout(char)[] suffix();

	final @property inout inout(char)[] path();

	final @property inout inout(char)[] file();

	const final override bool opEquals(Object o);

	const final bool opEquals(const(char)[] s);

	const final @property bool isAbsolute();

	const final @property bool isEmpty();

	const final @property bool isChild();

	final FilePath replace(char from, char to);

	final @property FilePath standard();

	final @property FilePath native();

	final FilePath cat(const(char[])[] others...);

	final FilePath append(const(char)[] path);

	final FilePath prepend(const(char)[] path);

	FilePath set(FilePath path);
	final FilePath set(const(char)[] path, bool convert = false);

	final @property FilePath isFolder(bool folder);

	final @property FilePath root(const(char)[] other);

	final @property FilePath folder(const(char)[] other);

	final @property FilePath name(const(char)[] other);

	final @property FilePath suffix(const(char)[] other);

	final @property FilePath path(const(char)[] other);

	final @property FilePath file(const(char)[] other);

	final FilePath pop();

	static char[] join(const(char[])[] paths...);

	final FilePath absolute(const(char)[] prefix);

	static inout(char)[] stripped(inout(char)[] path, char c = FileConst.PathSeparatorChar);

	static inout(char[]) padded(inout(char[]) path, char c = FileConst.PathSeparatorChar);

	static inout(char)[] prefixed(inout(char)[] s, char c = FileConst.PathSeparatorChar);

	private final FilePath parse();


	private final void expand(size_t size);


	private final int adjust(int head, int tail, int len, const(char)[] sub);


	final FilePath create();

	final FilePath[] toList(Filter filter = null);

	static FilePath from(ref FileInfo info);

	final @property inout bool exists();

	const final @property Time modified();

	const final @property Time accessed();

	const final @property Time created();

	final FilePath rename(FilePath dst);

	final inout inout(FilePath) copy(const(char)[] source);

	const final ulong fileSize();

	const final @property bool isWritable();

	const final @property bool isFolder();

	const final @property bool isFile();

	const final Stamps timeStamps();

	final inout inout(FilePath) copy(const(FilePath) src);

	final inout inout(FilePath) remove();

	final FilePath rename(const(char)[] dst);

	final inout inout(FilePath) createFile();

	final inout inout(FilePath) createFolder();

	const final int opApply(scope int delegate(ref FileInfo) dg);

}
interface PathView
{
	alias FS.Stamps Stamps;
	const immutable(char)[] toString();

	template cString()
	{
		inout inout(char)[] cString();

	}
	@property inout inout(char)[] root();

	@property inout inout(char)[] folder();

	@property inout inout(char)[] name();

	@property char[] ext();

	@property inout inout(char)[] suffix();

	@property inout inout(char)[] path();

	@property inout inout(char)[] file();

	const @property bool isAbsolute();

	const @property bool isEmpty();

	const @property bool isChild();

	@property inout bool exists();

	const @property Time modified();

	const @property Time accessed();

	const @property Time created();

	const @property ulong fileSize();

	const @property bool isWritable();

	const @property bool isFolder();

	const @property Stamps timeStamps();

}
debug (UnitTest)
{
}
debug (FilePath)
{
	import tango.io.Console;
	void main();
}
