// D import file generated from 'tango/io/FileSystem.d'
module tango.io.FileSystem;
private import tango.sys.Common;

private import tango.io.FilePath;

private import tango.core.Exception;

private import tango.io.Path : standard, native;

version (Win32)
{
	private import Text = tango.text.Util;

	private extern (Windows) DWORD GetLogicalDriveStringsA(DWORD, LPSTR);


	private import tango.stdc.stringz : fromString16z, fromStringz;

	enum 
	{
		FILE_DEVICE_DISK = 7,
		IOCTL_DISK_BASE = FILE_DEVICE_DISK,
		METHOD_BUFFERED = 0,
		FILE_READ_ACCESS = 1,
	}
	uint CTL_CODE(uint t, uint f, uint m, uint a);
	const IOCTL_DISK_GET_LENGTH_INFO = CTL_CODE(IOCTL_DISK_BASE, 23, METHOD_BUFFERED, FILE_READ_ACCESS);
}
version (Posix)
{
	private import tango.stdc.string;

	private 
	{
		import tango.stdc.posix.unistd;
		import tango.stdc.posix.sys.statvfs;
	}
	private import tango.io.device.File;

	private import Integer = tango.text.convert.Integer;

}
struct FileSystem
{
	private static void exception(string msg);


	version (Windows)
	{
		version (Win32SansUnicode)
		{
			private static void windowsPath(const(char)[] path, ref char[] result);


		}
		else
		{
			private static void windowsPath(const(char)[] path, ref wchar[] result);


		}
		deprecated static void setDirectory(const(char)[] path);


		deprecated static char[] getDirectory();


		@property static char[][] roots();


		private enum 
		{
			volumePathBufferLen = MAX_PATH + 6,
		}

		private static TCHAR[] getVolumePath(const(char)[] folder, TCHAR[] volPath_, bool trailingBackslash);


		static long freeSpace(const(char)[] folder, bool superuser = false);

		static ulong totalSpace(const(char)[] folder, bool superuser = false);

	}
	version (Posix)
	{
		deprecated static void setDirectory(const(char)[] path);


		deprecated static char[] getDirectory();


		@property static char[][] roots();


		static long freeSpace(const(char)[] folder, bool superuser = false);

		static long totalSpace(const(char)[] folder, bool superuser = false);

	}
}
debug (FileSystem)
{
	import tango.io.Stdout;
	static void foo(FilePath path);

	void main();
}
