// D import file generated from 'tango/io/device/Array.d'
module tango.io.device.Array;
private import tango.core.Exception;

private import tango.io.device.Conduit;

extern (C) protected void* memcpy(void* dst, const(void)* src, size_t);


class Array : Conduit, InputBuffer, OutputBuffer, Conduit.Seek
{
	private void[] data;

	private size_t index;

	private size_t extent;

	private size_t dimension;

	private size_t expansion;

	private immutable __gshared immutable(char)[] overflow = "output buffer is full";


	private immutable __gshared immutable(char)[] underflow = "input buffer is empty";


	private immutable __gshared immutable(char)[] eofRead = "end-of-flow while reading";


	private immutable __gshared immutable(char)[] eofWrite = "end-of-flow while writing";


	this(size_t capacity, size_t growing = 0);
	this(void[] data);
	this(void[] data, size_t readable);
	final override immutable(char)[] toString();

	final override size_t read(void[] dst);

	final override size_t write(const(void)[] src);

	const final override size_t bufferSize();

	override void detach();

	override long seek(long offset, Anchor anchor = Anchor.Begin);

	Array assign(void[] data);
	Array assign(void[] data, size_t readable);
	final void[] assign();

	final void[] opSlice(size_t start, size_t end);

	final void[] slice();

	final void[] slice(size_t size, bool eat = true);

	final Array append(const(void)[] src);

	final bool next(scope size_t delegate(const(void)[]) scan);

	const final @property size_t readable();

	const final @property size_t writable();

	const final @property size_t limit();

	const final size_t capacity();

	const final size_t position();

	final Array clear();

	final override Array flush();

	final size_t writer(scope size_t delegate(void[]) dg);

	final size_t reader(scope size_t delegate(const(void)[]) dg);

	private final size_t expand(size_t size);


	private static template convert(T)
	{
		T[] convert(void[] x)
		{
			return (cast(T*)x.ptr)[0..x.length / T.sizeof];
		}

	}


}
debug (Array)
{
	import tango.io.Stdout;
	void main();
}
