// D import file generated from 'tango/io/device/Conduit.d'
module tango.io.device.Conduit;
private 
{
	import tango.core.Thread;
	import tango.core.Exception;
}
public import tango.io.model.IConduit;

class Conduit : IConduit
{
	version (TangoRuntime)
	{
		protected Fiber.Scheduler scheduler;

	}
	private uint duration = -1;

	this();
	~this();
	abstract override string toString();

	const abstract size_t bufferSize();

	abstract size_t read(void[] dst);

	abstract size_t write(const(void)[] src);

	abstract void detach();

	final @property void timeout(uint millisec);

	const final @property uint timeout();

	const @property bool isAlive();

	final @property IConduit conduit();

	IOStream flush();
	void close();
	final void error(const(char[]) msg);

	final @property InputStream input();

	final @property OutputStream output();

	final Conduit put(void[] src);

	final Conduit get(void[] dst);

	final Conduit rewind();

	OutputStream copy(InputStream src, size_t max = -1);
	long seek(long offset, Anchor anchor = Anchor.Begin);
	template text(T = char)
	{
		char[] text(size_t max = -1)
		{
			return cast(T[])load(max);
		}

	}
	void[] load(size_t max = -1);
	static void[] load(InputStream src, size_t max = -1);

	static void put(void[] src, OutputStream output);

	static void get(void[] dst, InputStream input);

	static size_t transfer(InputStream src, OutputStream dst, size_t max = -1);

}
class InputFilter : InputStream
{
	protected InputStream source;

	this(InputStream source);
	@property IConduit conduit();

	size_t read(void[] dst);
	void[] load(size_t max = -1);
	IOStream flush();
	long seek(long offset, Anchor anchor = Anchor.Begin);
	@property InputStream input();

	void close();
}
class OutputFilter : OutputStream
{
	protected OutputStream sink;

	this(OutputStream sink);
	@property IConduit conduit();

	size_t write(const(void)[] src);
	OutputStream copy(InputStream src, size_t max = -1);
	IOStream flush();
	long seek(long offset, Anchor anchor = Anchor.Begin);
	@property OutputStream output();

	void close();
}
