// D import file generated from 'tango/io/device/File.d'
module tango.io.device.File;
private import tango.sys.Common;

private import tango.io.device.Device;

private import stdc = tango.stdc.stringz;

private import tango.core.Octal;

version (Win32)
{
	private import Utf = tango.text.convert.Utf;

}
else
{
	private import tango.stdc.posix.unistd;

}
class File : Device, Device.Seek, Device.Truncate
{
	public alias Device.read read;

	public alias Device.write write;

	align (1)struct Style
	{
		Access access;
		Open open;
		Share share;
		Cache cache;
	}

	enum Access : ubyte
	{
		Read = 1,
		Write = 2,
		ReadWrite = 3,
	}
	enum Open : ubyte
	{
		Exists = 0,
		Create,
		Sedate,
		Append,
		New,
	}
	enum Share : ubyte
	{
		None = 0,
		Read,
		ReadWrite,
	}
	enum Cache : ubyte
	{
		None = 0,
		Random = 1,
		Stream = 2,
		WriteThru = 4,
	}
	enum Style ReadExisting = {Access.Read, Open.Exists};
	enum Style ReadShared = {Access.Read, Open.Exists, Share.Read};
	enum Style WriteExisting = {Access.Write, Open.Exists};
	enum Style WriteCreate = {Access.Write, Open.Create};
	enum Style WriteAppending = {Access.Write, Open.Append};
	enum Style ReadWriteExisting = {Access.ReadWrite, Open.Exists};
	enum Style ReadWriteCreate = {Access.ReadWrite, Open.Create};
	enum Style ReadWriteOpen = {Access.ReadWrite, Open.Sedate};
	private const(char)[] path_;

	private Style style_;

	this();
	this(const(char[]) path, Style style = ReadExisting);
	const @property Style style();

	override immutable(char)[] toString();

	static void[] get(const(char)[] path, void[] dst = null);

	static void set(const(char)[] path, const(void)[] content);

	static void append(const(char)[] path, const(void)[] content);

	version (Win32)
	{
		protected bool open(const(char)[] path, Style style, DWORD addattr);

		void open(const(char[]) path, Style style = ReadExisting);
		void truncate();
		override void truncate(long size);

		override long seek(long offset, Anchor anchor = Anchor.Begin);

		@property long position();

		@property long length();

		void sync();
	}
	version (Posix)
	{
		protected bool open(const(char[]) path, Style style, int addflags, int access = octal!(666));

		void open(const(char[]) path, Style style = ReadExisting);
		void truncate();
		override void truncate(long size);

		override long seek(long offset, Anchor anchor = Anchor.Begin);

		@property long position();

		@property long length();

		void sync();
	}
}
debug (File)
{
	import tango.io.Stdout;
	void main();
}
