// D import file generated from 'tango/io/device/FileMap.d'
module tango.io.device.FileMap;
private import tango.sys.Common;

private 
{
	import tango.io.device.File;
	import tango.io.device.Array;
}
version (Win32)
{
	private extern (Windows) 
	{
		BOOL UnmapViewOfFile(LPCVOID);
		BOOL FlushViewOfFile(LPCVOID, DWORD);
		LPVOID MapViewOfFile(HANDLE, DWORD, DWORD, DWORD, DWORD);
		HANDLE CreateFileMappingA(HANDLE, LPSECURITY_ATTRIBUTES, DWORD, DWORD, DWORD, LPCTSTR);
	}

}
version (Posix)
{
	private import tango.stdc.posix.sys.mman;

}
class FileMap : Array
{
	private MappedFile file;

	this(const(char[]) path, File.Style style = File.ReadWriteOpen);
	final ubyte[] resize(long size);

	override void close();

}
class MappedFile
{
	private File host;

	this(const(char[]) path, File.Style style = File.ReadWriteOpen);
	final @property long length();

	final @property const(char)[] path();

	final ubyte[] resize(long size);

	version (Win32)
	{
		private void* base;

		private HANDLE mmFile;

		final @property ubyte[] map();

		final void close();

		private void reset();

		MappedFile flush();
	}
	version (Posix)
	{
		private void* base;

		private size_t size;

		final @property ubyte[] map();

		final void close();

		private void reset();

		final MappedFile flush();

	}
}
debug (FileMap)
{
	import tango.io.Path;
	void main();
}
