// D import file generated from 'tango/io/device/TempFile.d'
module tango.io.device.TempFile;
import Path = tango.io.Path;
import tango.math.random.Kiss : Kiss;
import tango.io.device.Device : Device;
import tango.io.device.File;
import tango.stdc.stringz : toStringz;
import tango.core.Octal;
version (Win32)
{
	import tango.sys.Common : DWORD, LONG, MAX_PATH, PCHAR, CP_UTF8;
	enum : DWORD
	{
		FILE_FLAG_OPEN_REPARSE_POINT = 2097152,
	}
	version (Win32SansUnicode)
	{
		import tango.sys.Common : GetVersionExA, OSVERSIONINFO, FILE_FLAG_DELETE_ON_CLOSE, GetTempPathA;
		char[] GetTempPath();
	}
	else
	{
		import tango.sys.Common : WideCharToMultiByte, GetVersionExW, OSVERSIONINFO, FILE_FLAG_DELETE_ON_CLOSE, GetTempPathW;
		char[] GetTempPath();
	}
	@property bool reparseSupported();

}
else
{
	version (Posix)
	{
		import tango.stdc.posix.pwd : getpwnam;
		import tango.stdc.posix.unistd : access, getuid, lseek, unlink, W_OK;
		import tango.stdc.posix.sys.types : off_t;
		import tango.stdc.posix.sys.stat : stat, stat_t;
		import tango.sys.consts.fcntl : O_NOFOLLOW;
		import tango.stdc.posix.stdlib : getenv;
		import tango.stdc.string : strlen;
	}
}
class TempFile : File
{
	enum Transience : ubyte
	{
		Transient,
		Permanent,
	}
	align (1)struct TempStyle
	{
		Transience transience;
		ubyte attempts = 10;
	}

	static const __gshared TempStyle Transient = {Transience.Transient};

	static const __gshared TempStyle Permanent = {Transience.Permanent};

	private char[] _path;

	private TempStyle _style;

	this(TempStyle style = TempStyle.init);
	this(const(char)[] prefix, TempStyle style = TempStyle.init);
	TempStyle tempStyle();
	private void open(TempStyle style);

	private void open(const(char)[] prefix, TempStyle style);

	version (Win32)
	{
		private static enum DEFAULT_LENGTH = 6;


		private static enum DEFAULT_PREFIX = "~t";


		private static enum DEFAULT_SUFFIX = ".tmp";


		private static enum JUNK_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";


		public static char[] tempPath();


		private bool openTempFile(const(char)[] path, TempStyle style);

	}
	else
	{
		version (Posix)
		{
			private static enum DEFAULT_LENGTH = 6;


			private static enum DEFAULT_PREFIX = ".tmp";


			private static enum DEFAULT_SUFFIX = "~";


			private static enum JUNK_CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";


			public static const(char)[] tempPath();


			private bool openTempFile(const(char)[] path, TempStyle style);

		}
		else
		{
			static assert(false, "Unsupported platform");
		}
	}
	private char[] randomName(size_t length = DEFAULT_LENGTH, const(char)[] prefix = DEFAULT_PREFIX, const(char)[] suffix = DEFAULT_SUFFIX);

	override void detach();

}
version (TempFile_SelfTest)
{
	import tango.io.Console : Cin;
	import tango.io.Stdout : Stdout;
	void main();
}
