// D import file generated from 'tango/io/selector/model/ISelector.d'
module tango.io.selector.model.ISelector;
public import tango.time.Time;

public import tango.io.model.IConduit;

enum Event : uint
{
	None = 0,
	Read = 1 << 0,
	UrgentRead = 1 << 1,
	Write = 1 << 2,
	Error = 1 << 3,
	Hangup = 1 << 4,
	InvalidHandle = 1 << 5,
}
struct SelectionKey
{
	ISelectable conduit;
	Event events;
	Object attachment;
	public bool isReadable();

	public bool isUrgentRead();

	public bool isWritable();

	public bool isError();

	public bool isHangup();

	public bool isInvalidHandle();

}
interface ISelectionSet
{
	public abstract size_t length();


	public abstract int opApply(scope int delegate(ref SelectionKey) dg);


}
interface ISelector
{
	public abstract void open(uint size, uint maxEvents);


	public abstract void close();


	public abstract void register(ISelectable conduit, Event events, Object attachment = null);


	deprecated public abstract void reregister(ISelectable conduit, Event events, Object attachment = null);



	public abstract void unregister(ISelectable conduit);


	public abstract int select();


	public abstract int select(TimeSpan timeout);


	public abstract int select(double timeout);


	public abstract ISelectionSet selectedSet();


	public abstract SelectionKey key(ISelectable conduit);


	public abstract int opApply(scope int delegate(ref SelectionKey sk) dg);


}
