// D import file generated from 'tango/io/stream/Buffered.d'
module tango.io.stream.Buffered;
public import tango.io.model.IConduit;

private import tango.io.device.Conduit;

public alias BufferedInput Bin;

public alias BufferedOutput Bout;

extern (C) 
{
	int printf(char*, ...);
	private void* memmove(void* dst, const(void)* src, size_t);

}
private immutable __gshared immutable(char)[] underflow = "input buffer is empty";


private immutable __gshared immutable(char)[] eofRead = "end-of-flow whilst reading";


private immutable __gshared immutable(char)[] eofWrite = "end-of-flow whilst writing";


private immutable __gshared immutable(char)[] overflow = "output buffer is full";


class BufferedInput : InputFilter, InputBuffer
{
	alias flush clear;
	alias InputFilter.input input;
	private void[] data;

	private size_t index;

	private size_t extent;

	private size_t dimension;

	this(InputStream stream);
	this(InputStream stream, size_t capacity);
	static InputBuffer create(InputStream stream);

	final size_t populate();

	final void[] opSlice(size_t start, size_t end);

	final void[] slice();

	final void[] slice(size_t size, bool eat = true);

	final size_t reader(scope size_t delegate(const(void)[]) dg);

	public size_t writer(scope size_t delegate(void[]) dg);

	final override size_t read(void[] dst);

	final size_t fill(void[] dst, bool exact = false);

	final bool skip(ptrdiff_t size);

	final override long seek(long offset, Anchor start = Anchor.Begin);

	final bool next(scope size_t delegate(const(void)[]) scan);

	final size_t reserve(size_t space);

	final @property BufferedInput compress();

	final size_t drain(OutputStream dst);

	const final @property size_t limit();

	const final size_t capacity();

	const final @property size_t position();

	const final @property size_t readable();

	static template convert(T)
	{
		inout(T)[] convert(inout(void)[] x)
		{
			return (cast(inout(T)*)x.ptr)[0..x.length / T.sizeof];
		}

	}

	final override BufferedInput flush();

	final @property void input(InputStream source);

	final override void[] load(size_t max = size_t.max);

	private size_t load(InputStream src, size_t increment, size_t max);

	private final BufferedInput set(void[] data, size_t readable);


	@property private const final size_t writable();



}
class BufferedOutput : OutputFilter, OutputBuffer
{
	alias OutputFilter.output output;
	private void[] data;

	private size_t index;

	private size_t extent;

	private size_t dimension;

	this(OutputStream stream);
	this(OutputStream stream, size_t capacity);
	static OutputBuffer create(OutputStream stream);

	final void[] slice();

	final override size_t write(const(void)[] src);

	final BufferedOutput append(const(void)[] src);

	final BufferedOutput append(const(void)* src, size_t length);

	const final @property size_t writable();

	const final @property size_t limit();

	const final size_t capacity();

	final bool truncate(size_t length);

	static template convert(T)
	{
		T[] convert(void[] x)
		{
			return (cast(T*)x.ptr)[0..x.length / T.sizeof];
		}

	}

	final override BufferedOutput flush();

	final override BufferedOutput copy(InputStream src, size_t max = -1);

	final size_t drain(OutputStream dst);

	final BufferedOutput clear();

	final @property void output(OutputStream sink);

	final override long seek(long offset, Anchor start = Anchor.Begin);

	final size_t writer(scope size_t delegate(void[]) dg);

	private final size_t reader(scope size_t delegate(const(void)[]) dg);


	@property private const final size_t readable();



	private final BufferedOutput set(void[] data, size_t readable);


	@property private final BufferedOutput compress();



}
debug (Buffered)
{
	void main();
}
