// D import file generated from 'tango/io/stream/Bzip.d'
module tango.io.stream.Bzip;
private import tango.util.compress.c.bzlib;

private import tango.core.Exception : IOException;

private import tango.io.device.Conduit : InputFilter, OutputFilter;

private import tango.io.model.IConduit : InputStream, OutputStream, IConduit;

private 
{
	private enum 
	{
		BUFFER_SIZE = 4 * 1024,
	}

	private enum 
	{
		DEFAULT_BLOCKSIZE = 9,
	}

	private enum 
	{
		DEFAULT_WORKFACTOR = 0,
	}

}
class BzipOutput : OutputFilter
{
	enum BlockSize : int
	{
		Normal = 9,
		Fast = 1,
		Best = 9,
	}
	private 
	{
		bool bzs_valid = false;
		bz_stream bzs;
		ubyte[] out_chunk;
		size_t _written = 0;
	}
	this(OutputStream stream, int blockSize = BlockSize.Normal);
	private void init(OutputStream stream, int blockSize);

	~this();
	void reset(OutputStream stream, int blockSize = BlockSize.Normal);
	override size_t write(const(void)[] src);

	size_t written();
	override void close();

	void commit();
	override long seek(long offset, Anchor anchor = Anchor.Begin);

	private void kill_bzs();

	private void check_valid();

}
class BzipInput : InputFilter
{
	private 
	{
		bool bzs_valid = false;
		bz_stream bzs;
		ubyte[] in_chunk;
	}
	this(InputStream stream, bool small = false);
	private void init(InputStream stream, bool small);

	~this();
	void reset(InputStream stream, bool small = false);
	override size_t read(void[] dst);

	override void close();

	override long seek(long offset, Anchor anchor = Anchor.Begin);

	private void kill_bzs();

	private void check_valid();

}
class BzipException : IOException
{
	this(in int code);
	this(string msg);
	private string codeName(in int code);

}
class BzipClosedException : IOException
{
	this();
}
class BzipStillOpenException : IOException
{
	this();
}
debug (UnitTest)
{
	import tango.io.device.Array : Array;
}
