// D import file generated from 'tango/io/stream/Utf.d'
module tango.io.stream.Utf;
private import tango.io.device.Conduit;

private import tango.io.stream.Buffered;

private import Utf = tango.text.convert.Utf;

template UtfInput(T, S)
{
	class UtfInput : InputFilter, InputFilter.Mutator
	{
		static if (!is(S == char) && !is(S == wchar) && !is(S == dchar))
		{
			pragma (msg, "Source type must be char, wchar, or dchar");
		}
		static if (!is(T == char) && !is(T == wchar) && !is(T == dchar))
		{
			pragma (msg, "Target type must be char, wchar, or dchar");
		}
		private InputBuffer buffer;

		this(InputStream stream)
		{
			super(buffer = BufferedInput.create(stream));
		}

		final size_t consume(T[] dst)
		{
			auto x = read(dst);
			if (x != Eof)
				x /= T.sizeof;
			return x;
		}


		final override size_t read(void[] dst)
		{
			static if (is(S == T))
			{
				return super.read(dst);
			}
			else
			{
				size_t consumed, produced;
				size_t reader(const(void)[] src);
				if (dst.length < T.sizeof)
					conduit.error("UtfStream.read :: target array is too small");
				if (buffer.next(&reader) is false)
					return Eof;
				return produced * T.sizeof;
			}

		}


	}
}
template UtfOutput(S, T)
{
	class UtfOutput : OutputFilter, OutputFilter.Mutator
	{
		static if (!is(S == char) && !is(S == wchar) && !is(S == dchar))
		{
			pragma (msg, "Source type must be char, wchar, or dchar");
		}
		static if (!is(T == char) && !is(T == wchar) && !is(T == dchar))
		{
			pragma (msg, "Target type must be char, wchar, or dchar");
		}
		private OutputBuffer buffer;

		this(OutputStream stream)
		{
			super(buffer = BufferedOutput.create(stream));
		}

		final size_t consume(const(S)[] dst)
		{
			auto x = write(dst);
			if (x != Eof)
				x /= S.sizeof;
			return x;
		}


		final override size_t write(const(void)[] src)
		{
			static if (is(S == T))
			{
				return super.write(src);
			}
			else
			{
				uint consumed, produced;
				size_t writer(void[] dst);
				if (buffer.writer(&writer) is Eof)
				{
					buffer.flush;
					if (buffer.writer(&writer) is Eof)
						return Eof;
				}
				return consumed * S.sizeof;
			}

		}


	}
}
debug (Utf)
{
	import tango.io.Stdout;
	import tango.io.device.Array;
	void main();
}
