// D import file generated from 'tango/io/vfs/FileFolder.d'
module tango.io.vfs.FileFolder;
private import tango.io.device.File;

private import Path = tango.io.Path;

private import tango.core.Exception;

public import tango.io.vfs.model.Vfs;

private import tango.io.model.IConduit;

private import tango.time.Time : Time;

class FileFolder : VfsFolder
{
	private const(char)[] path;

	private VfsStats stats;

	this(const(char)[] path, bool create = false);
	private this(const(char)[] path, const(char)[] name);

	private this(FileFolder parent, const(char)[] name, bool create = false);

	final @property const(char)[] name();

	final override string toString();

	final void verify(VfsFolder folder, bool mounting);

	final @property VfsFile file(const(char)[] name);

	final @property VfsFolderEntry folder(const(char)[] path);

	final VfsFolder clear();

	final @property bool writable();

	final @property VfsFolders self();

	final @property VfsFolders tree();

	final int opApply(scope int delegate(ref VfsFolder) dg);

	VfsFolder close(bool commit = true);
	@property private FileFolder[] folders(bool collect);


	private char[][] files(ref VfsStats stats, VfsFilter filter = null);

	private const(char)[] error(string msg);

	private const(char)[] open(const(char)[] path, bool create);

}
class FileGroup : VfsFiles
{
	private const(char)[][] group;

	private const(char)[][] hosts;

	private VfsStats stats;

	this(FolderGroup host, VfsFilter filter);
	final int opApply(scope int delegate(ref VfsFile) dg);

	final @property size_t files();

	final @property ulong bytes();

}
private class FolderGroup : VfsFolders
{
	private FileFolder[] members;

	private this();

	private this(FileFolder root, bool recurse);

	final int opApply(scope int delegate(ref VfsFolder) dg);

	final @property size_t files();

	final @property ulong bytes();

	final @property size_t folders();

	final @property size_t entries();

	final VfsFolders subset(const(char)[] pattern);

	final @property FileGroup catalog(const(char)[] pattern);

	final @property FileGroup catalog(VfsFilter filter = null);

	private final FileFolder[] scan(FileFolder root, bool recurse);


}

private class FolderHost : VfsFolderEntry
{
	private const(char)[] path;

	private FileFolder parent;

	private this(FileFolder parent, const(char)[] path);

	final VfsFolder create();

	final VfsFolder open();

	@property bool exists();

}

private class FileHost : VfsFile
{
	private Path.PathParser!(const(char)) path;

	this(const(char)[] path = null);
	final @property const(char)[] name();

	final override string toString();

	final @property bool exists();

	final @property ulong size();

	final VfsFile create();

	final VfsFile create(InputStream input);

	VfsFile copy(VfsFile source);
	final VfsFile move(VfsFile source);

	final @property InputStream input();

	final @property OutputStream output();

	final VfsFile remove();

	final @property VfsFile dup();

	final @property Time modified();

}

debug (FileFolder)
{
	import tango.io.Stdout;
	import tango.io.device.Array;
	void main();
}
