// D import file generated from 'tango/io/vfs/FtpFolder.d'
module tango.io.vfs.FtpFolder;
private 
{
	import tango.net.ftp.FtpClient;
	import tango.io.vfs.model.Vfs;
	import tango.io.vfs.FileFolder;
	import tango.io.device.Conduit;
	import tango.text.Util;
	import Time = tango.time.Time;
}
private const(char)[] fixName(const(char)[] toFix);

private const(char)[] checkFirst(const(char)[] toFix);

private const(char)[] checkLast(const(char)[] toFix);

private const(char)[] checkCat(const(char)[] first, const(char)[] last);

private FtpFileInfo[] getEntries(FTPConnection ftp, const(char)[] path = "");

private FtpFileInfo[] getFiles(FTPConnection ftp, const(char)[] path = "");

private FtpFileInfo[] getFolders(FTPConnection ftp, const(char)[] path = "");

class FtpFolderEntry : VfsFolderEntry
{
	const(char)[] toString_;
	const(char)[] name_;
	const(char)[] username_;
	const(char)[] password_;
	uint port_;
	public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21);

	final VfsFolder open();

	final VfsFolder create();

	final @property bool exists();

}
class FtpFolder : VfsFolder
{
	const(char)[] toString_;
	const(char)[] name_;
	const(char)[] username_;
	const(char)[] password_;
	uint port_;
	public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21);

	final @property const(char)[] name();

	final override string toString();

	final @property VfsFile file(const(char)[] path);

	final @property VfsFolderEntry folder(const(char)[] path);

	final @property VfsFolders self();

	final @property VfsFolders tree();

	final int opApply(scope int delegate(ref VfsFolder) dg);

	final VfsFolder clear();

	final @property bool writable();

	VfsFolder close(bool commit = true);
	void verify(VfsFolder folder, bool mounting);
}
class FtpFolders : VfsFolders
{
	const(char)[] toString_;
	const(char)[] name_;
	const(char)[] username_;
	const(char)[] password_;
	uint port_;
	bool flat_;
	FtpFileInfo[] infos_;
	package this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21, FtpFileInfo[] infos = null, bool flat = false);

	public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21, bool flat = false);

	final int opApply(scope int delegate(ref VfsFolder) dg);

	final @property size_t files();

	final @property size_t folders();

	final @property size_t entries();

	final @property ulong bytes();

	final VfsFolders subset(const(char)[] pattern);

	final @property VfsFiles catalog(const(char)[] pattern);

	final @property VfsFiles catalog(VfsFilter filter = null);

}
class FtpFile : VfsFile
{
	const(char)[] toString_;
	const(char)[] name_;
	const(char)[] username_;
	const(char)[] password_;
	uint port_;
	bool conOpen;
	FTPConnection conn;
	public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21);

	final @property const(char)[] name();

	final override string toString();

	final @property bool exists();

	final @property ulong size();

	final VfsFile copy(VfsFile source);

	final VfsFile move(VfsFile source);

	final VfsFile create();

	final VfsFile create(InputStream stream);

	final VfsFile remove();

	final @property InputStream input();

	final @property OutputStream output();

	final @property VfsFile dup();

	final @property Time.Time mtime();

	final @property Time.Time ctime();

	final @property Time.Time atime();

	final @property Time.Time modified();

}
class FtpFiles : VfsFiles
{
	const(char)[] toString_;
	const(char)[] name_;
	const(char)[] username_;
	const(char)[] password_;
	uint port_;
	FtpFileInfo[] infos_;
	public this(const(char)[] server, const(char)[] path, const(char)[] username = "", const(char)[] password = "", uint port = 21, FtpFileInfo[] infos = null);

	final void fillInfos();

	final int opApply(scope int delegate(ref VfsFile) dg);

	final @property size_t files();

	final @property ulong bytes();

}
