// D import file generated from 'tango/io/vfs/VirtualFolder.d'
module tango.io.vfs.VirtualFolder;
private import tango.core.Exception;

private import tango.io.model.IFile;

private import tango.io.vfs.model.Vfs;

private import tango.io.Path : patternMatch;

private import tango.text.Util : head, locatePrior;

class VirtualFolder : VfsHost
{
	private const(char)[] name_;

	private VfsFile[const(char)[]] files;

	private VfsFolder[const(char)[]] mounts;

	private VfsFolderEntry[const(char)[]] folders;

	private VirtualFolder parent;

	this(const(char)[] name);
	final @property const(char)[] name();

	final override string toString();

	VfsHost mount(VfsFolder folder, const(char)[] name = null);
	VfsHost mount(VfsFolders group);
	VfsHost dismount(VfsFolder folder);
	final VfsHost map(VfsFile file, const(char)[] name);

	final VfsHost map(VfsFolderEntry folder, const(char)[] name);

	final int opApply(scope int delegate(ref VfsFolder) dg);

	final VfsFolderEntry folder(const(char)[] path);

	@property VfsFile file(const(char)[] path);

	final VfsFolder clear();

	final @property bool writable();

	final @property VfsFolders self();

	final @property VfsFolders tree();

	final void verify(VfsFolder folder, bool mounting);

	VfsFolder close(bool commit = true);
	package final string error(string msg);


	private final void validate(const(char)[] name);


}
private class VirtualFolders : VfsFolders
{
	private VfsFolders[] members;

	private this();

	private this(VirtualFolder root, bool recurse);

	final int opApply(scope int delegate(ref VfsFolder) dg);

	final @property size_t files();

	final @property ulong bytes();

	final @property size_t folders();

	final @property size_t entries();

	final VfsFolders subset(const(char)[] pattern);

	final @property VfsFiles catalog(const(char)[] pattern);

	final @property VfsFiles catalog(VfsFilter filter = null);

}

private class VirtualFiles : VfsFiles
{
	private VfsFiles[] members;

	private this(VirtualFolders host, VfsFilter filter);

	final int opApply(scope int delegate(ref VfsFile) dg);

	final @property size_t files();

	final @property ulong bytes();

}

debug (VirtualFolder)
{
	import tango.io.Stdout;
	import tango.io.vfs.FileFolder;
	void main();
}
