// D import file generated from 'tango/net/Uri.d'
module tango.net.Uri;
public import tango.net.model.UriView;

private import tango.core.Exception;

private import Integer = tango.text.convert.Integer;

private import tango.stdc.string : memchr;

class Uri : UriView
{
	private alias size_t delegate(const(void)[]) Consumer;

	public alias port getPort;

	public alias defaultPort getDefaultPort;

	public alias scheme getScheme;

	public alias host getHost;

	public alias validPort getValidPort;

	public alias userinfo getUserInfo;

	public alias path getPath;

	public alias query getQuery;

	public alias fragment getFragment;

	public alias port setPort;

	public alias scheme setScheme;

	public alias host setHost;

	public alias userinfo setUserInfo;

	public alias query setQuery;

	public alias path setPath;

	public alias fragment setFragment;

	public enum 
	{
		InvalidPort = -1,
	}

	private int port_;

	private 
	{
		const(char)[] host_;
		const(char)[] path_;
		const(char)[] query_;
		const(char)[] scheme_;
		const(char)[] userinfo_;
		const(char)[] fragment_;
	}
	private HeapSlice decoded;

	private __gshared ubyte[] map;


	private __gshared short[immutable(char)[]] genericSchemes;


	private immutable __gshared immutable(char)[] hexDigits = "0123456789abcdef";


	private const __gshared SchemePort[] schemePorts = [{"coffee", 80}, {"file", InvalidPort}, {"ftp", 21}, {"gopher", 70}, {"hnews", 80}, {"http", 80}, {"http-ng", 80}, {"https", 443}, {"imap", 143}, {"irc", 194}, {"ldap", 389}, {"news", 119}, {"nfs", 2049}, {"nntp", 119}, {"pop", 110}, {"rwhois", 4321}, {"shttp", 80}, {"smtp", 25}, {"snews", 563}, {"telnet", 23}, {"wais", 210}, {"whois", 43}, {"whois++", 43}];


	public enum 
	{
		ExcScheme = 1,
		ExcAuthority = 2,
		ExcPath = 4,
		IncUser = 128,
		IncPath = 16,
		IncQuery = 32,
		IncQueryAll = 64,
		IncScheme = 128,
		IncGeneric = IncScheme | IncUser | IncPath | IncQuery | IncQueryAll,
	}

	private struct SchemePort
	{
		const(char)[] name;
		short port;
	}

	shared static this();
	this();
	this(const(char)[] uri);
	this(const(char)[] scheme, const(char)[] host, const(char)[] path, const(char)[] query = null);
	this(UriView other);
	const final override int defaultPort(const(char)[] scheme);

	const final override @property const(char)[] scheme();

	const final override @property const(char)[] host();

	const final override @property int port();

	const final override int validPort();

	const final override @property const(char)[] userinfo();

	const final override @property const(char)[] path();

	const final override @property const(char)[] query();

	const final override @property const(char)[] fragment();

	const final override @property bool isGeneric();

	const final size_t produce(Consumer consume);

	final override string toString();

	static size_t encode(Consumer consume, const(char)[] s, int flags);

	static char[] encode(const(char)[] text, int flags);

	private const(char)[] decoder(const(char)[] s, char ignore = 0);

	final char[] decode(const(char)[] s);

	final Uri parse(const(char)[] uri, bool relative = false);

	final void reset();

	final Uri relParse(const(char)[] uri);

	final @property Uri scheme(const(char)[] scheme);

	final @property Uri host(const(char)[] host);

	final @property Uri port(int port);

	final @property Uri userinfo(const(char)[] userinfo);

	final @property Uri query(const(char)[] query);

	final const(char)[] extendQuery(const(char)[] tail);

	final @property Uri path(const(char)[] path);

	final @property Uri fragment(const(char)[] fragment);

	private void parseAuthority(const(char)[] auth);

	private final static template toLastSlash(T)
	{
		T[] toLastSlash(T[] path)
		{
			if (path.ptr)
			{
				for (auto p = path.ptr + path.length;
				 --p >= path.ptr;)
				{
					if (*p is '/')
						return path[0..p - path.ptr + 1];
				}
			}
			return path;
		}

	}



	private final static char[] toLower(ref char[] src);



}
private struct HeapSlice
{
	private size_t used;

	private void[] buffer;

	final void reset();

	final void* expand(size_t size);

	final void[] slice(int size);

}

debug (UnitTest)
{
	import tango.util.log.Trace;
}
