// D import file generated from 'tango/net/device/Socket.d'
module tango.net.device.Socket;
private import tango.sys.Common;

private import tango.io.device.Conduit;

package import tango.net.device.Berkeley;

version (Windows)
{
	private import tango.sys.win32.WsaSock;

}
class Socket : Conduit, ISelectable
{
	public alias native socket;

	private SocketSet pending;

	private Berkeley berkeley;

	deprecated void setTimeout(double t);

	deprecated bool hadTimeout();

	this();
	this(Address addr);
	this(AddressFamily family, SocketType type, ProtocolType protocol);
	override string toString();

	@property Handle fileHandle();

	@property Berkeley* native();

	const override @property size_t bufferSize();

	Socket connect(const(char)[] address, uint port);
	Socket connect(Address addr);
	Socket bind(Address address);
	Socket shutdown();
	override void detach();

	override size_t read(void[] dst);

	override size_t write(const(void)[] src);

	override OutputStream copy(InputStream src, size_t max = -1);

	package final bool wait(bool reading);


	final void error();

	version (Win32)
	{
		private OVERLAPPED overlapped;

		private void asyncConnect(Address addr);

		private void asyncCopy(Handle handle);

		private size_t asyncRead(void[] dst);

		private size_t asyncWrite(const(void)[] src);

		version (TangoRuntime)
		{
			private size_t wait(scheduler.Type type, uint bytes = 0);

		}
		private static void patch(socket_t dst, uint how, socket_t* src = null);


	}
	version (Posix)
	{
		private void asyncConnect(Address addr);

		Socket asyncCopy(Handle file);
		private size_t asyncRead(void[] dst);

		private size_t asyncWrite(const(void)[] src);

	}
}
class ServerSocket : Socket
{
	this(uint port, int backlog = 32, bool reuse = false);
	this(Address addr, int backlog = 32, bool reuse = false);
	override string toString();

	Socket accept(Socket recipient = null);
	version (Windows)
	{
		private void asyncAccept(Socket recipient);

	}
	version (Posix)
	{
		private void asyncAccept(Socket recipient);

	}
}
