// D import file generated from 'tango/net/http/HttpClient.d'
module tango.net.http.HttpClient;
private import tango.time.Time;

private 
{
	import tango.net.Uri;
	import tango.net.device.Socket;
	import tango.net.InternetAddress;
}
private import tango.io.device.Array;

private import tango.io.stream.Lines;

private import tango.io.stream.Buffered;

private 
{
	import tango.net.http.HttpConst;
	import tango.net.http.HttpParams;
	import tango.net.http.HttpHeaders;
	import tango.net.http.HttpTriplet;
	import tango.net.http.HttpCookies;
}
private import tango.core.Exception : IOException;

private import Integer = tango.text.convert.Integer;

class HttpClient
{
	alias void delegate(OutputBuffer) Pump;
	private struct RequestMethod
	{
		const(char)[] name;
	}

	private Uri uri;

	private BufferedInput input;

	private BufferedOutput output;

	private Array tokens;

	private Lines!(char) line;

	private Socket socket;

	private RequestMethod method;

	private InternetAddress address;

	private HttpParams paramsOut;

	private HttpHeadersView headersIn;

	private HttpHeaders headersOut;

	private HttpCookies cookiesOut;

	private ResponseLine responseLine;

	private float timeout = 3.00000;

	private bool encode = true;

	private bool doRedirect = true;

	private bool keepalive = false;

	private 
	{
		uint redirections;
		uint redirectionLimit = 5;
	}
	private const(char)[] httpVersion;

	public enum Version 
	{
		OnePointZero,
		OnePointOne,
	}

	enum RequestMethod Get = {"GET"};
	enum RequestMethod Put = {"PUT"};
	enum RequestMethod Head = {"HEAD"};
	enum RequestMethod Post = {"POST"};
	enum RequestMethod Trace = {"TRACE"};
	enum RequestMethod Delete = {"DELETE"};
	enum RequestMethod Options = {"OPTIONS"};
	enum RequestMethod Connect = {"CONNECT"};
	this(RequestMethod method, const(char)[] url);
	this(RequestMethod method, Uri uri);
	HttpHeadersView getResponseHeaders();
	HttpHeaders getRequestHeaders();
	HttpParams getRequestParams();
	UriView getUri();
	ResponseLine getResponse();
	int getStatus();
	bool isResponseOK();
	HttpClient addCookie(Cookie cookie);
	void close();
	HttpClient reset();
	HttpClient setRequest(RequestMethod method);
	HttpClient setVersion(Version v);
	HttpClient enableRedirect(bool yes = true);
	HttpClient setTimeout(float interval);
	HttpClient keepAlive(bool yes = true);
	HttpClient encodeUri(bool yes = true);
	InputBuffer open();
	InputBuffer open(Pump pump);
	InputBuffer open(RequestMethod method, Pump pump);
	void read(scope void delegate(const(void)[]) sink, size_t len = size_t.max);
	InputBuffer redirectPost(Pump pump, int status);
	bool canRepost(uint status);
	protected Socket createSocket();

	private void error(const(char)[] msg);

}
private class ResponseLine : HttpTriplet
{
	private 
	{
		const(char)[] vers;
		const(char)[] reason;
	}
	private int status;

	override bool test();

	const(char)[] getVersion();
	const(char)[] getReason();
	int getStatus();
}

debug (HttpClient)
{
	import tango.io.Stdout;
	void main();
}
