// D import file generated from 'tango/net/http/HttpStack.d'
module tango.net.http.HttpStack;
private import tango.core.Exception;

version (Win32)
{
	extern (C) int memicmp(const(char)*, const(char)*, size_t);

}
version (Posix)
{
	extern (C) int strncasecmp(const(char)*, const(char)*, size_t);

}
extern (C) void* memmove(void* dst, const(void)* src, int n);

class Token
{
	private const(char)[] value;

	Token set(const(char)[] value);
	override string toString();

}
class HttpStack
{
	private int depth;

	private Token[] tokens;

	private static const int MaxHttpStackSize = 256;


	this(int size = 10);
	HttpStack clone();
	int opApply(scope int delegate(ref Token) dg);
	final void reset();

	final Token findToken(const(char)[] match);

	final bool removeToken(const(char)[] match);

	final @property int size();

	final Token push(const(char)[] content);

	final Token push(ref Token token);

	final Token push();

	final void pop();

	final static bool isMatch(ref Token token, const(char)[] match);


	final static void resize(ref Token[] tokens, int size);


}
