// D import file generated from 'tango/net/http/HttpTokens.d'
module tango.net.http.HttpTokens;
private import tango.time.Time;

private import tango.io.device.Array;

private import tango.io.stream.Buffered;

private 
{
	import tango.net.http.HttpStack;
	import tango.net.http.HttpConst;
}
private import Text = tango.text.Util;

private import Integer = tango.text.convert.Integer;

private import TimeStamp = tango.text.convert.TimeStamp;

struct HttpToken
{
	const(char)[] name;
	const(char)[] value;
}
class HttpTokens
{
	protected HttpStack stack;

	private Array input;

	private Array output;

	private bool parsed;

	private bool inclusive;

	private char separator;

	private char[1] sepString;

	this(char separator, bool inclusive = false);
	this(HttpTokens source);
	abstract void parse(InputBuffer input);

	void parse(char[] content);
	HttpTokens reset();
	bool isParsed();
	void setParsed(bool parsed);
	const(char)[] get(const(char)[] name, const(char)[] ret = null);
	int getInt(const(char)[] name, int ret = -1);
	Time getDate(const(char)[] name, Time date = Time.epoch);
	int opApply(scope int delegate(ref HttpToken) dg);
	void produce(scope size_t delegate(const(void)[]) consume, const(char)[] eol = null);
	protected bool handleMissingSeparator(const(char)[] s, ref HttpToken element);

	final private bool split(Token t, ref HttpToken element);


	FilteredTokens createFilter(char[] match);
	private static class FilteredTokens
	{
		private const(char)[] match;

		private HttpTokens tokens;

		this(HttpTokens tokens, const(char)[] match);
		int opApply(scope int delegate(ref HttpToken) dg);
	}


	private bool isSpace(char c);

	private inout(char)[] trim(inout(char)[] source);

	char[] formatTokens(OutputBuffer dst, const(char)[] delim);
	protected void add(const(char)[] name, scope void delegate(OutputBuffer) value);

	protected void add(const(char)[] name, const(char)[] value);

	protected void addInt(const(char)[] name, size_t value);

	protected void addDate(const(char)[] name, Time value);

	protected bool remove(const(char)[] name);

}
