// D import file generated from 'tango/net/util/PKI.d'
module tango.net.util.PKI;
private import tango.time.Time;

private import tango.stdc.stringz;

private import tango.net.util.c.OpenSSL;

const int SSL_VERIFY_NONE = 0;

const int SSL_VERIFY_PEER = 1;

const int SSL_VERIFY_FAIL_IF_NO_PEER_CERT = 2;

const int SSL_VERIFY_CLIENT_ONCE = 4;

const int SSL_SESS_CACHE_SERVER = 2;

extern (C) alias int function(int, X509_STORE_CTX* ctx) SSLVerifyCallback;

class SSLCtx
{
	private SSL_CTX* _ctx = null;

	private Certificate _cert = null;

	private PrivateKey _key = null;

	private CertificateStore _store = null;

	this();
	~this();
	@property SSL_CTX* native();

	SSLCtx certificate(Certificate cert);
	SSLCtx privateKey(PrivateKey key);
	@property SSLCtx checkKey();

	SSLCtx setVerification(int flags, SSLVerifyCallback cb);
	SSLCtx store(CertificateStore store);
	SSLCtx caCertsPath(const(char)[] path);
}
class CertificateStoreCtx
{
	private X509_STORE_CTX* _ctx = null;

	this(X509_STORE_CTX* ctx);
	Certificate cert();
	int error();
	int errorDepth();
}
class CertificateStore
{
	package X509_STORE* _store = null;

	Certificate[] _certs;
	this();
	~this();
	CertificateStore add(Certificate cert);
}
class PublicKey
{
	package EVP_PKEY* _evpKey = null;

	private PrivateKey _existingKey = null;

	this(const(char)[] publicPemData);
	package this(PrivateKey key);

	~this();
	string pemFormat();
	bool verify(const(ubyte)[] data, const(ubyte)[] signature);
	ubyte[] encrypt(const(ubyte)[] data);
	ubyte[] decrypt(const(ubyte)[] data);
}
class PrivateKey
{
	package EVP_PKEY* _evpKey = null;

	this(const(char)[] privatePemData, const(char)[] certPass = null);
	this(int bits);
	~this();
	override bool opEquals(Object obj);

	string pemFormat(const(char)[] pass = null);
	PublicKey publicKey();
	ubyte[] sign(const(ubyte)[] data, ubyte[] sigbuf);
	ubyte[] encrypt(const(ubyte)[] data);
	ubyte[] decrypt(const(ubyte)[] data);
}
class Certificate
{
	package X509* _cert = null;

	private bool readOnly = true;

	private bool freeIt = true;

	package this(X509* cert);

	this(const(ubyte)[] publicPemData);
	this();
	~this();
	Certificate serialNumber(uint serial);
	uint serialNumber();
	Certificate dateBeforeOffset(TimeSpan t);
	Certificate dateAfterOffset(TimeSpan t);
	char[] dateAfter();
	char[] dateBefore();
	Certificate privateKey(PrivateKey key);
	Certificate setSubject(const(char)[] country, const(char)[] stateProvince, const(char)[] city, const(char)[] organization, const(char)[] cn, const(char)[] organizationalUnit = null, const(char)[] email = null);
	char[] subject();
	Certificate sign(Certificate caCert, PrivateKey caKey);
	override bool opEquals(Object obj);

	bool verify(CertificateStore store);
	string pemFormat();
	private void addNameEntry(X509_NAME* name, const(char)* type, const(char)[] value);

	private void checkFlag();

}
version (Test)
{
	import util.Test;
	import tango.io.Stdout;
	auto t1 = TimeSpan.zero;
	auto t2 = TimeSpan.fromDays(365);
}
