// D import file generated from 'tango/sys/Environment.d'
module tango.sys.Environment;
private import tango.sys.Common;

private 
{
	import tango.io.Path;
	import tango.io.FilePath;
}
private import tango.core.Exception;

private import tango.io.model.IFile;

private import Text = tango.text.Util;

private import tango.core.Octal;

version (Windows)
{
	private import tango.text.convert.Utf;

	pragma (lib, "kernel32.lib");
	extern (Windows) 
	{
		private void* GetEnvironmentStringsW();

		private bool FreeEnvironmentStringsW(wchar**);

	}
	extern (Windows) 
	{
		private int SetEnvironmentVariableW(const(wchar)*, const(wchar)*);

		private uint GetEnvironmentVariableW(const(wchar)*, wchar*, uint);

		private const int ERROR_ENVVAR_NOT_FOUND = 203;


	}
}
else
{
	version (darwin)
	{
		extern (C) char*** _NSGetEnviron();

		private __gshared char** environ;


		shared static this();
	}
	else
	{
		private extern (C) extern __gshared char** environ;



	}
	import tango.stdc.posix.stdlib;
	import tango.stdc.string;
}
struct Environment
{
	public alias cwd directory;

	private static void exception(immutable(char)[] msg);


	static char[] toAbsolute(char[] path);

	static FilePath exePath(char[] file);

	version (Windows)
	{
		static char[] get(const(char)[] variable, char[] def = null);

		static void set(const(char)[] variable, const(char)[] value = null);

		static char[][char[]] get();

		static void cwd(const(char)[] path);

		static char[] cwd();

	}
	version (Posix)
	{
		static char[] get(const(char)[] variable, char[] def = null);

		static void set(const(char)[] variable, const(char)[] value = null);

		static char[][char[]] get();

		static void cwd(const(char)[] path);

		static char[] cwd();

	}
}
debug (Environment)
{
	import tango.io.Console;
	void main(const(char)[][] args);
}
