// D import file generated from 'tango/sys/Pipe.d'
module tango.sys.Pipe;
private import tango.sys.Common;

private import tango.io.device.Device;

private import tango.core.Exception;

version (Posix)
{
	private import tango.stdc.posix.unistd;

}
debug (PipeConduit)
{
	private import tango.io.Stdout;

}
private enum 
{
	DefaultBufferSize = 8 * 1024,
}

class PipeConduit : Device
{
	version (OLD)
	{
		alias Device.fileHandle fileHandle;
		alias Device.copy copy;
		alias Device.read read;
		alias Device.write write;
		alias Device.close close;
		alias Device.error error;
	}
	private uint _bufferSize;

	private this(Handle handle, uint bufferSize = DefaultBufferSize);

	public ~this();

	public const override size_t bufferSize();


	public override immutable(char)[] toString();


	version (OLD)
	{
		protected override uint read(void[] dst);


		protected override uint write(const(void)[] src);


	}
}
class Pipe
{
	private PipeConduit _source;

	private PipeConduit _sink;

	public this(uint bufferSize = DefaultBufferSize);

	version (Windows)
	{
		package this(uint bufferSize, SECURITY_ATTRIBUTES* sa);

	}
	@property public PipeConduit sink();


	@property public PipeConduit source();


	private final void error();


}
