// D import file generated from 'tango/text/convert/DateTime.d'
module tango.text.convert.DateTime;
private import tango.core.Exception;

private import tango.time.WallClock;

private 
{
	import tango.time.chrono.Calendar;
	import tango.time.chrono.Gregorian;
}
private import Utf = tango.text.convert.Utf;

private import Integer = tango.text.convert.Integer;

version (WithExtensions)
{
	private import tango.text.convert.Extensions;

}
version (Windows)
{
	private import tango.sys.win32.UserGdi;

}
else
{
	private import tango.stdc.stringz;

	private import tango.stdc.posix.langinfo;

}
public __gshared DateTimeLocale DateTimeDefault;


shared static this();
struct DateTimeLocale
{
	immutable __gshared immutable(char)[] rfc1123Pattern = "ddd, dd MMM yyyy HH':'mm':'ss 'GMT'";

	immutable __gshared immutable(char)[] sortableDateTimePattern = "yyyy'-'MM'-'dd'T'HH':'mm':'ss";

	immutable __gshared immutable(char)[] universalSortableDateTimePattern = "yyyy'-'MM'-'dd' 'HH':'mm':'ss'Z'";

	Calendar assignedCalendar;
	const(char)[] shortDatePattern;
	const(char)[] shortTimePattern;
	const(char)[] longDatePattern;
	const(char)[] longTimePattern;
	const(char)[] fullDateTimePattern;
	const(char)[] generalShortTimePattern;
	const(char)[] generalLongTimePattern;
	const(char)[] monthDayPattern;
	const(char)[] yearMonthPattern;
	const(char)[] amDesignator;
	const(char)[] pmDesignator;
	const(char)[] timeSeparator;
	const(char)[] dateSeparator;
	const(char)[][] dayNames;
	const(char)[][] monthNames;
	const(char)[][] abbreviatedDayNames;
	const(char)[][] abbreviatedMonthNames;
	char[] format(char[] output, Time dateTime, const(char)[] layout);
	template formatWide(T)
	{
		T[] formatWide(T[] output, Time dateTime, const(T)[] fmt)
		{
			static if (is(T == char))
			{
				return format(output, dateTime, fmt);
			}
			else
			{
				char[128] tmp0 = void;
				char[128] tmp1 = void;
				return Utf.fromString8(format(tmp0, dateTime, Utf.toString(fmt, tmp1)), output);
			}

		}

	}
	@property static DateTimeLocale* generic();


	@property Calendar calendar();

	const(char)[] abbreviatedDayName(Calendar.DayOfWeek dayOfWeek);
	const(char)[] dayName(Calendar.DayOfWeek dayOfWeek);
	const(char)[] abbreviatedMonthName(int month);
	const(char)[] monthName(int month);
	version (Windows)
	{
		static DateTimeLocale create();

	}
	else
	{
		static DateTimeLocale create();

		private static char[] convert(const(char)[] fmt);


	}
	private const(char)[] expandKnownFormat(const(char)[] format);

	private char[] formatCustom(ref Result result, Time dateTime, const(char)[] format);

	private const(char)[] formatMonth(int month, int rpt);

	private const(char)[] formatDayOfWeek(Calendar.DayOfWeek dayOfWeek, int rpt);

	private template bridge(T)
	{
		T[] bridge(T[] result, void* arg, const(T)[] format)
		{
			return formatWide(result, *cast(Time*)arg, format);
		}

	}

	private static int parseRepeat(const(char)[] format, int pos, char c);


	private static char[] formatInt(char[] tmp, int v, int minimum);


	private static int parseQuote(ref Result result, const(char)[] format, int pos);


}
private DateTimeLocale EngUS = {shortDatePattern:"M/d/yyyy", shortTimePattern:"h:mm", longDatePattern:"dddd, MMMM d, yyyy", longTimePattern:"h:mm:ss tt", fullDateTimePattern:"dddd, MMMM d, yyyy h:mm:ss tt", generalShortTimePattern:"M/d/yyyy h:mm", generalLongTimePattern:"M/d/yyyy h:mm:ss tt", monthDayPattern:"MMMM d", yearMonthPattern:"MMMM, yyyy", amDesignator:"AM", pmDesignator:"PM", timeSeparator:":", dateSeparator:"/", dayNames:["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], monthNames:["January", "February", "March", "April", "May", "June", "July", "August", "September", "OctoberNovember", "December"], abbreviatedDayNames:["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], abbreviatedMonthNames:["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "OctNov", "Dec"]};

private struct Result
{
	private size_t index;

	private char[] target_;

	private static Result opCall(char[] target);


	private void opCatAssign(const(char)[] rhs);

	private void opCatAssign(char rhs);

	@property private char[] get();


}

debug (DateTime)
{
	import tango.io.Stdout;
	void main();
}
