// D import file generated from 'tango/text/locale/Core.d'
module tango.text.locale.Core;
private import tango.core.Exception;

private import tango.text.locale.Data;

private import tango.time.Time;

private 
{
	import tango.time.chrono.Hijri;
	import tango.time.chrono.Korean;
	import tango.time.chrono.Taiwan;
	import tango.time.chrono.Hebrew;
	import tango.time.chrono.Calendar;
	import tango.time.chrono.Japanese;
	import tango.time.chrono.Gregorian;
	import tango.time.chrono.ThaiBuddhist;
}
version (Windows)
{
	private import tango.text.locale.Win32;

}
version (Posix)
{
	private import tango.text.locale.Posix;

}
private template arrayOf(T)
{
	private T[] arrayOf(T[] params...)
	{
		return params.dup;
	}


}

public enum CultureTypes 
{
	Neutral = 1,
	Specific = 2,
	All = Neutral | Specific,
}

public interface IFormatService
{
	Object getFormat(TypeInfo type);
}

public class Culture : IFormatService
{
	private enum int LCID_INVARIANT = 127;

	private static Culture[immutable(char)[]] namedCultures;


	private static Culture[int] idCultures;


	private static Culture[immutable(char)[]] ietfCultures;


	private static Culture currentCulture_;


	private static Culture userDefaultCulture_;


	private static Culture invariantCulture_;


	private Calendar calendar_;

	private Culture parent_;

	private const(CultureData)* cultureData_;

	private bool isReadOnly_;

	private NumberFormat numberFormat_;

	private DateTimeFormat dateTimeFormat_;

	shared static this();
	public this(const(char)[] cultureName);

	public this(int cultureID);

	public Object getFormat(TypeInfo type);

	version (Clone)
	{
		public Object clone();

	}
	public static Culture getCulture(int cultureID);


	public static Culture getCulture(const(char)[] cultureName);


	public static Culture getCultureFromIetfLanguageTag(const(char)[] name);


	private static Culture getCultureInternal(int cultureID, const(char)[] cname);


	public static Culture[] getCultures(CultureTypes types);


	public override immutable(char)[] toString();


	public override bool opEquals(Object obj);


	@property public static Culture current();



	@property public static void current(Culture value);



	@property public static Culture invariantCulture();



	@property public const int id();



	@property public const const(char)[] name();



	@property public const const(char)[] englishName();



	@property public const const(char)[] nativeName();



	@property public const const(char)[] twoLetterLanguageName();



	@property public const const(char)[] threeLetterLanguageName();



	@property public const final const(char)[] ietfLanguageTag();



	@property public Culture parent();


	@property public const bool isNeutral();



	@property public const final bool isReadOnly();



	@property public Calendar calendar();


	@property public Calendar[] optionalCalendars();


	@property public NumberFormat numberFormat();


	@property public void numberFormat(NumberFormat value);


	@property public DateTimeFormat dateTimeFormat();


	@property public void dateTimeFormat(DateTimeFormat value);


	private static void checkNeutral(Culture culture);


	private void checkReadOnly();

	private static Calendar getCalendarInstance(int calendarType, bool readOnly = false);


}

public class Region
{
	private const(CultureData)* cultureData_;

	private static Region currentRegion_;


	private const(char)[] name_;

	public this(int cultureID);

	public this(const(char)[] name);

	package this(const(CultureData)* cultureData);

	@property public static Region current();



	@property public const int geoID();



	@property public const const(char)[] name();



	@property public const const(char)[] englishName();



	@property public const const(char)[] nativeName();



	@property public const const(char)[] twoLetterRegionName();



	@property public const const(char)[] threeLetterRegionName();



	@property public const const(char)[] currencySymbol();



	@property public const const(char)[] isoCurrencySymbol();



	@property public const const(char)[] currencyEnglishName();



	@property public const const(char)[] currencyNativeName();



	@property public const bool isMetric();



	public override immutable(char)[] toString();


}

public class NumberFormat : IFormatService
{
	package bool isReadOnly_;

	private static NumberFormat invariantFormat_;


	private int numberDecimalDigits_;

	private int numberNegativePattern_;

	private int currencyDecimalDigits_;

	private int currencyNegativePattern_;

	private int currencyPositivePattern_;

	private const(int)[] numberGroupSizes_;

	private const(int)[] currencyGroupSizes_;

	private const(char)[] numberGroupSeparator_;

	private const(char)[] numberDecimalSeparator_;

	private const(char)[] currencyGroupSeparator_;

	private const(char)[] currencyDecimalSeparator_;

	private const(char)[] currencySymbol_;

	private const(char)[] negativeSign_;

	private const(char)[] positiveSign_;

	private const(char)[] nanSymbol_;

	private const(char)[] negativeInfinitySymbol_;

	private const(char)[] positiveInfinitySymbol_;

	private const(char[])[] nativeDigits_;

	public this();

	package this(const(CultureData)* cultureData);

	public Object getFormat(TypeInfo type);

	version (Clone)
	{
		public Object clone();

	}
	public static NumberFormat getInstance(IFormatService formatService);


	@property public static NumberFormat current();



	public static NumberFormat invariantFormat();


	@property public const final bool isReadOnly();



	@property public const final int numberDecimalDigits();



	@property public final void numberDecimalDigits(int value);



	@property public const final int numberNegativePattern();



	@property public final void numberNegativePattern(int value);



	@property public const final int currencyDecimalDigits();



	@property public final void currencyDecimalDigits(int value);



	@property public const final int currencyNegativePattern();



	@property public final void currencyNegativePattern(int value);



	@property public const final int currencyPositivePattern();



	@property public final void currencyPositivePattern(int value);



	@property public const final const(int)[] numberGroupSizes();



	@property public final void numberGroupSizes(const(int)[] value);



	@property public const final const(int)[] currencyGroupSizes();



	@property public final void currencyGroupSizes(const(int)[] value);



	@property public const final const(char)[] numberGroupSeparator();



	@property public final void numberGroupSeparator(const(char)[] value);



	@property public const final const(char)[] numberDecimalSeparator();



	@property public final void numberDecimalSeparator(const(char)[] value);



	@property public const final const(char)[] currencyGroupSeparator();



	@property public final void currencyGroupSeparator(const(char)[] value);



	@property public const final const(char)[] currencyDecimalSeparator();



	@property public final void currencyDecimalSeparator(const(char)[] value);



	@property public const final const(char)[] currencySymbol();



	@property public final void currencySymbol(const(char)[] value);



	@property public const final const(char)[] negativeSign();



	@property public final void negativeSign(const(char)[] value);



	@property public const final const(char)[] positiveSign();



	@property public final void positiveSign(const(char)[] value);



	@property public const final const(char)[] nanSymbol();



	@property public final void nanSymbol(const(char)[] value);



	@property public const final const(char)[] negativeInfinitySymbol();



	@property public final void negativeInfinitySymbol(const(char)[] value);



	@property public const final const(char)[] positiveInfinitySymbol();



	@property public final void positiveInfinitySymbol(const(char)[] value);



	@property public const final const(char[])[] nativeDigits();



	@property public final void nativeDigits(const(char[])[] value);



	@property private const void checkReadOnly();



}

public class DateTimeFormat : IFormatService
{
	private immutable __gshared const(char)[] rfc1123Pattern_ = "ddd, dd MMM yyyy HH':'mm':'ss 'GMT'";


	private immutable __gshared const(char)[] sortableDateTimePattern_ = "yyyy'-'MM'-'dd'T'HH':'mm':'ss";


	private immutable __gshared const(char)[] universalSortableDateTimePattern_ = "yyyy'-'MM'-'dd' 'HH':'mm':'ss'Z'";


	private immutable __gshared const(char)[] allStandardFormats = ['d', 'D', 'f', 'F', 'g', 'G', 'm', 'M', 'r', 'R', 's', 't', 'T', 'u', 'U', 'y', 'Y'];


	package bool isReadOnly_;

	private __gshared DateTimeFormat invariantFormat_;


	private const(CultureData)* cultureData_;

	private Calendar calendar_;

	private const(int)[] optionalCalendars_;

	private int firstDayOfWeek_ = -1;

	private int calendarWeekRule_ = -1;

	private const(char)[] dateSeparator_;

	private const(char)[] timeSeparator_;

	private const(char)[] amDesignator_;

	private const(char)[] pmDesignator_;

	private const(char)[] shortDatePattern_;

	private const(char)[] shortTimePattern_;

	private const(char)[] longDatePattern_;

	private const(char)[] longTimePattern_;

	private const(char)[] monthDayPattern_;

	private const(char)[] yearMonthPattern_;

	private const(char[])[] abbreviatedDayNames_;

	private const(char[])[] dayNames_;

	private const(char[])[] abbreviatedMonthNames_;

	private const(char[])[] monthNames_;

	private const(char)[] fullDateTimePattern_;

	private const(char)[] generalShortTimePattern_;

	private const(char)[] generalLongTimePattern_;

	private const(char[])[] shortTimePatterns_;

	private const(char[])[] shortDatePatterns_;

	private const(char[])[] longTimePatterns_;

	private const(char[])[] longDatePatterns_;

	private const(char[])[] yearMonthPatterns_;

	package this();

	package this(const(CultureData)* cultureData, Calendar calendar);

	public Object getFormat(TypeInfo type);

	version (Clone)
	{
		public Object clone();

	}
	@property package const(char)[][] shortTimePatterns();


	@property package const(char)[][] shortDatePatterns();


	@property package const(char)[][] longTimePatterns();


	@property package const(char)[][] longDatePatterns();


	@property package const(char[])[] yearMonthPatterns();


	public final const(char)[][] getAllDateTimePatterns();


	public final const(char)[][] getAllDateTimePatterns(char format);


	public final const(char)[] getAbbreviatedDayName(Calendar.DayOfWeek dayOfWeek);


	public final const(char)[] getDayName(Calendar.DayOfWeek dayOfWeek);


	public final const(char)[] getAbbreviatedMonthName(int month);


	public final const(char)[] getMonthName(int month);


	public static DateTimeFormat getInstance(IFormatService formatService);


	@property public static DateTimeFormat current();



	public static DateTimeFormat invariantFormat();


	@property public final bool isReadOnly();



	@property public final Calendar calendar();



	@property public final void calendar(Calendar value);



	@property public final Calendar.DayOfWeek firstDayOfWeek();



	@property public final void firstDayOfWeek(Calendar.DayOfWeek value);



	@property public final Calendar.WeekRule calendarWeekRule();



	@property public final void calendarWeekRule(Calendar.WeekRule value);



	@property public final const(char)[] nativeCalendarName();



	@property public final const(char)[] dateSeparator();



	@property public final void dateSeparator(const(char)[] value);



	@property public final const(char)[] timeSeparator();



	@property public final void timeSeparator(const(char)[] value);



	@property public final const(char)[] amDesignator();



	@property public final void amDesignator(const(char)[] value);



	@property public final const(char)[] pmDesignator();



	@property public final void pmDesignator(const(char)[] value);



	@property public final const(char)[] shortDatePattern();



	@property public final void shortDatePattern(const(char)[] value);



	@property public final const(char)[] shortTimePattern();



	@property public final void shortTimePattern(const(char)[] value);



	@property public final const(char)[] longDatePattern();



	@property public final void longDatePattern(const(char)[] value);



	@property public final const(char)[] longTimePattern();



	@property public final void longTimePattern(const(char)[] value);



	@property public final const(char)[] monthDayPattern();



	@property public final void monthDayPattern(const(char)[] value);



	@property public final const(char)[] yearMonthPattern();



	@property public final void yearMonthPattern(const(char)[] value);



	@property public final const(char)[][] abbreviatedDayNames();



	@property public final void abbreviatedDayNames(const(char)[][] value);



	@property public final const(char)[][] dayNames();



	@property public final void dayNames(const(char)[][] value);



	@property public final const(char)[][] abbreviatedMonthNames();



	@property public final void abbreviatedMonthNames(const(char)[][] value);



	@property public final const(char)[][] monthNames();



	@property public final void monthNames(const(char)[][] value);



	@property public final const(char)[] fullDateTimePattern();



	@property public final void fullDateTimePattern(const(char)[] value);



	@property public const final const(char)[] rfc1123Pattern();



	@property public const final const(char)[] sortableDateTimePattern();



	@property public const final const(char)[] universalSortableDateTimePattern();



	@property package const(char)[] generalShortTimePattern();


	@property package const(char)[] generalLongTimePattern();


	@property private const void checkReadOnly();



	private void initialize();

	@property private const(int)[] optionalCalendars();


	private const void error(immutable(char)[] msg);


}

