// D import file generated from 'tango/text/xml/DocPrinter.d'
module tango.text.xml.DocPrinter;
private import tango.io.model.IConduit;

private import tango.text.xml.Document;

private import tango.core.Exception : XmlException;

template DocPrinter(T)
{
	class DocPrinter
	{
		public alias Document!(T) Doc;

		public alias Doc.Node Node;

		private bool quick = true;

		private uint indentation = 2;

		version (Win32)
		{
			private immutable __gshared const(T)[] Eol = "\x0d\x0a";


		}
		else
		{
			private immutable __gshared const(T)[] Eol = "\x0a";


		}
		final DocPrinter indent(uint indentation)
		{
			this.indentation = indentation;
			return this;
		}


		final DocPrinter cache(bool yes)
		{
			this.quick = yes;
			return this;
		}


		final T[] print(Doc doc, T[] content = null)
		{
			if (content !is null)
				print(doc.tree, (const(T)[][] s...)
				{
					size_t i = 0;
					foreach (t; s)
					{
						if (i + t.length >= content.length)
							throw new XmlException("Buffer is to small");
						content[i..t.length] = t[];
						i += t.length;
					}
					content.length = i;
				}
				);
			else
				print(doc.tree, (const(T)[][] s...)
				{
					foreach (t; s)
					{
						content ~= t;
					}
				}
				);
			return content;
		}


		final void print(Doc doc, OutputStream stream)
		{
			print(doc.tree, (const(T)[][] s...)
			{
				foreach (t; s)
				{
					stream.write(t);
				}
			}
			);
		}


		final void print(Node root, scope void delegate(const(T)[][]...) emit)
		{
			T[256] tmp;
			T[256] spaces = ' ';
			const(T)[] rawValue(Node node);
			void printNode(Node node, uint indent);
			printNode(root, 0);
		}


	}
}
debug (1)
{
	import tango.text.xml.Document;
}
debug (1)
{
	import tango.util.log.Trace;
}
