// D import file generated from 'tango/time/chrono/Calendar.d'
module tango.time.chrono.Calendar;
public import tango.time.Time;

private import tango.core.Exception;

public abstract class Calendar
{
	package enum 
	{
		CURRENT_ERA = 0,
	}

	package enum 
	{
		GREGORIAN = 1,
		GREGORIAN_US = 2,
		JAPAN = 3,
		TAIWAN = 4,
		KOREA = 5,
		HIJRI = 6,
		THAI = 7,
		HEBREW = 8,
		GREGORIAN_ME_FRENCH = 9,
		GREGORIAN_ARABIC = 10,
		GREGORIAN_XLIT_ENGLISH = 11,
		GREGORIAN_XLIT_FRENCH = 12,
	}

	package enum WeekRule 
	{
		FirstDay,
		FirstFullWeek,
		FirstFourDayWeek,
	}

	package enum DatePart 
	{
		Year,
		Month,
		Day,
		DayOfYear,
	}

	public enum DayOfWeek 
	{
		Sunday,
		Monday,
		Tuesday,
		Wednesday,
		Thursday,
		Friday,
		Saturday,
	}

	const Date toDate(const(Time) time);

	const void split(const(Time) time, ref uint year, ref uint month, ref uint day, ref uint doy, ref uint dow, ref uint era);

	const Time toTime(uint year, uint month, uint day, uint hour, uint minute, uint second, uint millisecond = 0);

	const Time toTime(const(Date) d);

	const Time toTime(const(DateTime) dt);

	const Time toTime(const(Date) d, const(TimeOfDay) t);

	const abstract Time toTime(uint year, uint month, uint day, uint hour, uint minute, uint second, uint millisecond, uint era);

	const abstract DayOfWeek getDayOfWeek(const(Time) time);

	const abstract uint getDayOfMonth(const(Time) time);

	const abstract uint getDayOfYear(const(Time) time);

	const abstract uint getMonth(const(Time) time);

	const abstract uint getYear(const(Time) time);

	const abstract uint getEra(const(Time) time);

	const uint getDaysInMonth(uint year, uint month);

	const abstract uint getDaysInMonth(uint year, uint month, uint era);

	const uint getDaysInYear(uint year);

	const abstract uint getDaysInYear(uint year, uint era);

	const uint getMonthsInYear(uint year);

	const abstract uint getMonthsInYear(uint year, uint era);

	const uint getWeekOfYear(const(Time) time, WeekRule rule, DayOfWeek firstDayOfWeek);

	const bool isLeapYear(uint year);

	const abstract bool isLeapYear(uint year, uint era);

	const abstract @property uint[] eras();

	const @property uint id();

	const Time addMonths(const(Time) t, int nMonths, bool truncateDay = false);

	const Time addYears(const(Time) t, int nYears);

	package static long getTimeTicks(uint hour, uint minute, uint second);


}


