// D import file generated from 'tango/time/chrono/Gregorian.d'
module tango.time.chrono.Gregorian;
private import tango.time.chrono.Calendar;

private import tango.core.Exception;

class Gregorian : Calendar
{
	alias Calendar.toTime toTime;
	public static __gshared Gregorian generic;


	enum Type 
	{
		Localized = 1,
		USEnglish = 2,
		MiddleEastFrench = 9,
		Arabic = 10,
		TransliteratedEnglish = 11,
		TransliteratedFrench = 12,
	}
	private Type type_;

	enum 
	{
		AD_ERA = 1,
		BC_ERA = 2,
		MAX_YEAR = 9999,
	}
	private immutable __gshared uint[] DaysToMonthCommon = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365];


	private immutable __gshared uint[] DaysToMonthLeap = [0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366];


	shared static this();
	this(Type type = Type.Localized);
	const override Time toTime(uint year, uint month, uint day, uint hour, uint minute, uint second, uint millisecond, uint era);

	const override DayOfWeek getDayOfWeek(const(Time) time);

	const override uint getDayOfMonth(const(Time) time);

	const override uint getDayOfYear(const(Time) time);

	const override uint getMonth(const(Time) time);

	const override uint getYear(const(Time) time);

	const override uint getEra(const(Time) time);

	const override uint getDaysInMonth(uint year, uint month, uint era);

	const override uint getDaysInYear(uint year, uint era);

	const override uint getMonthsInYear(uint year, uint era);

	const override bool isLeapYear(uint year, uint era);

	const @property Type calendarType();

	const override @property uint[] eras();

	const override @property uint id();

	const override void split(const(Time) time, ref uint year, ref uint month, ref uint day, ref uint doy, ref uint dow, ref uint era);

	const override Time addMonths(const(Time) t, int nMonths, bool truncateDay = false);

	const override Time addYears(const(Time) t, int nYears);

	package static void splitDate(long ticks, ref uint year, ref uint month, ref uint day, ref uint dayOfYear, ref uint era);


	package static uint extractPart(long ticks, DatePart part);


	package static long getDateTicks(uint year, uint month, uint day, uint era);


	package static bool staticIsLeapYear(uint year, uint era);


	package static void argumentError(const(char[]) str);


}
debug (Gregorian)
{
	import tango.io.Stdout;
	void output(Time t);
	void main();
}
debug (UnitTest)
{
}
