// D import file generated from 'tango/time/chrono/Hebrew.d'
module tango.time.chrono.Hebrew;
private import tango.core.Exception;

private import tango.time.chrono.Calendar;

public class Hebrew : Calendar
{
	private immutable __gshared uint[14][7] MonthDays = [[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0], [0, 30, 29, 29, 29, 30, 29, 0, 30, 29, 30, 29, 30, 29], [0, 30, 29, 30, 29, 30, 29, 0, 30, 29, 30, 29, 30, 29], [0, 30, 30, 30, 29, 30, 29, 0, 30, 29, 30, 29, 30, 29], [0, 30, 29, 29, 29, 30, 30, 29, 30, 29, 30, 29, 30, 29], [0, 30, 29, 30, 29, 30, 30, 29, 30, 29, 30, 29, 30, 29], [0, 30, 30, 30, 29, 30, 30, 29, 30, 29, 30, 29, 30, 29]];


	private enum uint YearOfOneAD = 3760;

	private enum uint DaysToOneAD = cast(int)(YearOfOneAD * 0xb.6a3020c49ba5e35p+5);

	private enum uint PartsPerHour = 1080;

	private enum uint PartsPerDay = 24 * PartsPerHour;

	private enum uint DaysPerMonth = 29;

	private enum uint DaysPerMonthFraction = 12 * PartsPerHour + 793;

	private enum uint PartsPerMonth = DaysPerMonth * PartsPerDay + DaysPerMonthFraction;

	private enum uint FirstNewMoon = 11 * PartsPerHour + 204;

	private uint minYear_ = YearOfOneAD + 1583;

	private uint maxYear_ = YearOfOneAD + 2240;

	public enum uint HEBREW_ERA = 1;

	public const override Time toTime(uint year, uint month, uint day, uint hour, uint minute, uint second, uint millisecond, uint era);


	public const override DayOfWeek getDayOfWeek(const(Time) time);


	public const override uint getDayOfMonth(const(Time) time);


	public const override uint getDayOfYear(const(Time) time);


	public const override uint getMonth(const(Time) time);


	public const override uint getYear(const(Time) time);


	public const override uint getEra(const(Time) time);


	public const override uint getDaysInMonth(uint year, uint month, uint era);


	public const override uint getDaysInYear(uint year, uint era);


	public const override uint getMonthsInYear(uint year, uint era);


	public const override bool isLeapYear(uint year, uint era);


	public const override uint[] eras();


	public const override uint id();


	private const void checkYear(uint year, uint era);


	private const uint getYearType(uint year);


	private const uint getStartOfYear(uint year);


	private const Time getGregorianTime(uint year, uint month, uint day, uint hour, uint minute, uint second, uint millisecond);


}

