// D import file generated from 'tango/util/digest/MerkleDamgard.d'
module tango.util.digest.MerkleDamgard;
public import tango.core.ByteSwap;

public import tango.util.digest.Digest;

package class MerkleDamgard : Digest
{
	private uint bytes;

	private ubyte[] buffer;

	protected abstract void createDigest(ubyte[] buf);


	protected abstract uint blockSize();


	@property protected abstract uint addSize();



	protected abstract void padMessage(ubyte[] data);


	protected void padLength(ubyte[] data, ulong length);

	protected abstract void transform(const(ubyte[]) data);


	protected void extend();

	this();
	protected void reset();

	override MerkleDamgard update(const(void[]) input);

	override ubyte[] binaryDigest(ubyte[] buf = null);

	static protected final void littleEndian32(const(ubyte[]) input, uint[] output);



	static protected final void bigEndian32(const(ubyte[]) input, uint[] output);



	static protected final void littleEndian64(const(ubyte[]) input, ulong[] output);



	static protected final void bigEndian64(const(ubyte[]) input, ulong[] output);



	static protected final uint rotateLeft(uint x, uint n);



}

